//kek
#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

#define forn(i, n) for (int i = 1; i <= n; i++)
#define pb push_back
#define all(x) x.begin(), x.end()
#define y1 qewr1234 

const int DIR = 4;
const int X[] = {1, 0, -1, 0};
const int Y[] = {0, 1, 0, -1};
const double PI = acos(-1.0);

ll binpow(ll a, ll b, ll mod)
{ 
	ll res = 1;
	while(b)
	{
		if (b & 1)
			res = res * a % mod;
		a = a * a % mod;
		b >>= 1;
	}	
	return res;
}

ll phi(ll x)
{
	return (x - x / 2) - (x - x / 2) / 5;	
}

ll getFirst(ll x)
{
	while(x >= 10)
		x /= 10;
	return x;	
}

void deleteFirst(ll & x)
{
	ll res = 0;
	ll deg = 1;
	while(x >= 10)
	{
		res += (x % 10) * deg;
		deg *= 10;
		x /= 10;
	}
	x = res;
}

int main() 
{
	//ios_base::sync_with_stdio(false);
	//cin.tie();
	//cout.tie();


	ll a, b;
	cin >> a >> b;
	ll mod = 1;
	while(mod <= b)
		mod *= 10;
	ll x = (b - (a % mod) + mod) % mod;
	x = x % mod * binpow(9, phi(mod) - 1, mod) % mod;
	if ((a + 9 * x) % mod == b)
	{
		vector < pair < int, int > > ans;
		ll cur = a;

		while(x > 0 || cur >= mod)
		{		
			if (cur >= mod)
			{
				if (getFirst(cur) != 1)
				{
					cout <<"Broken" << endl;
					return 0;
				}
				deleteFirst(cur);
				ans.pb({2, 1});
			}			
			else
			{
				ll k = min((mod - cur - 1) / 9 + 1, x);
				ans.pb({1, k});
				cur += 9 * k;
				x -= k;	
			}
		}
		cout << "Stable" << endl;
		cout << (int)ans.size() << endl;
		for (auto it : ans)
		{
			if (it.first == 1)
				cout << "+ " << it.second << endl;
			else
				cout << "- " << it.second << endl;
		}
	}	
	else
	{
		cout << "Broken" << endl;
	}


	//cerr << 1.0 * clock() / CLOCKS_PER_SEC << endl;

	return 0;
}
	
