#include <iostream>
#include <vector>

std::vector <std::string> ans;

long long factor[12] = {-1, 1, 10, 100, 1000, 10000, 100000, 1000000, 10000000, 100000000, 1000000000, 10000000000};

void decrease_once(int i) {
    /// i-   1
    std::string s = "+ 1";
    for (size_t ii = 1; ii < i; ++ii)
        s += '0';
    ans.push_back(s);
    ans.push_back("- 1");
    return;
}

void decrease(int id, int n) {
    for (size_t i = 0; i < n; ++i)
        decrease_once(id);
    return;
}



int main() {
    int a, b;
    std::cin >> a >> b;

    std::cout << "Stable" << std::endl;

    int ma[11], mb[11];

    for (int i = 10; i > 0; --i) {
        ma[i] = (a % factor[i + 1]) / factor[i];
        mb[i] = (b % factor[i + 1]) / factor[i];
    }

    for (int i = 10; i > 0; --i) {
        if (ma[i] != 0) decrease(i, ma[i]);
        //std::cout << i << " : " << ma[i] << " | ";
    }

    std::string s = "+ 1";

    for (int i = 1; i <= 10; ++i) {
        if (mb[i] != 0) {
            ans.push_back(s);
            if (9 - mb[i] != 0) decrease(i, 9 - mb[i]);
            s += '0';
        }
    }

    std::cout << ans.size() << std::endl;

    for (size_t i = 0; i < ans.size(); ++i) {
        std::cout << ans[i] << std::endl;
    }

    return 0;

}
