#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>

#define ll long long

using namespace std;

ll len(ll x) {
    if (x == 0)
        return 1ll;

    ll r = 0ll;
    while (x > 0) {
        x /= 10ll;
        r++;
    }
    return r;
}

ll proc(ll num) {
    ll r = 0;
    vector <int> d;
    while (num > 0) {
        d.push_back(num % 10);
        num /= 10;
    }
    ll i = 0;
    reverse(d.begin(), d.end());
    while (d[i] == 1)
        r++;
    return r;
}

int main() {


    ll a, b;
    cin >> a >> b;

    if (a % 9ll == b % 9ll) {
        cout << "Stable" << endl;
        cout << '+' << abs(a - b) / 9ll;
        return 0;
    }

    if (a < b) {
        ll cnt = 0ll;
        while (a % 9ll != b % 9ll) {
            a = pow(10ll, len(a)) + a;
            cnt++;
        }
        cout << "Stable" << endl;
        cout << '+' << a / 9 << endl;
        cout << '-' << cnt;
        return 0;
    }

    cout << "Stable" << endl;

    while (a > b) {
        cout << '+' << pow(10ll, len(a) - 1) << endl;
        a += (9 * pow(10ll, len(a) - 1));
        cout << "-1" << endl;
        a = a - pow(10ll, len(a) - 1);
    }

    ll cnt = 0ll;
    while (a % 9ll != b % 9ll) {
        a = pow(10ll, len(a)) + a;
        cnt++;
    }
    cout << '+' << a / 9 << endl;
    cout << '-' << cnt;

    return 0;
}
