#include <bits/stdc++.h>

using namespace std;

struct stc
{
    int x, y;
};

stc way[2200];
int arr[2100][2100];
int h, w, way_size;

void gen_quest(char ch)
{
    cout << ch << " ";
    way[0].x = 1;
    way[0].y = 1;
    bool mode = 1;
    for (int x=1, y=1, i=1;; i++) {
        if ( x == h && y == w ) {
            cout << endl;
            return;
        }

        if ( arr[x][y+1] == 0 && arr[x+1][y] == 0 ) {
            if ( mode ) {
                cout << 'R';
                y++;
            } else {
                cout << 'D';
                x++;
            }
            mode = !mode;
        }

        if ( arr[x][y+1] == 1 ) {
            cout << 'R';
            y++;
        } else if ( arr[x+1][y] == 1 ) {
            cout << 'D';
            x++;
        }
        way[i].x = x;
        way[i].y = y;

    }
}

int main()
{
    queue < pair <int, int> > que;
    int n, a, b, s = 0;
    cin >> h >> w;
    way_size = h + w - 1;
    arr[1][1] = 1;
    arr[h][w] = 1;
    s = 2;

    for (;;) {
        gen_quest('?');
        cin >> n;
        while (n--) {
            cin >> a >> b;
            if (  arr[a][b] != 1 ) {
                s++;
                arr[a][b] = 1;
            }
            que.push( {a, b} );
        }

        for (int i=0; i<way_size; i++) {
            if ( arr[ way[i].x ][ way[i].y ] != 1 )
                arr[ way[i].x ][ way[i].y ] = -1;
        }

        while ( !que.empty() ) {
            auto v = que.front();
            que.pop();

            if ( arr[ v.first ][ v.second + 1 ] == -1 && arr[ v.first + 1 ][ v.second ] == 0 ) {
                arr[ v.first + 1 ][ v.second ] = 1;
                s++;
                que.push( { v.first + 1, v.second } );
            };
            if ( arr[ v.first + 1 ][ v.second ] == -1 && arr[ v.first ][ v.second + 1 ] == 0 ) {
                arr[ v.first ][ v.second + 1 ] = 1;
                s++;
                que.push( { v.first, v.second + 1 } );
            };
            if ( arr[ v.first ][ v.second - 1 ] == -1 && arr[ v.first - 1 ][ v.second ] == 0 ) {
                arr[ v.first - 1 ][ v.second ] = 1;
                s++;
                que.push( { v.first - 1, v.second } );
            };
            if ( arr[ v.first - 1 ][ v.second ] == -1 && arr[ v.first ][ v.second - 1 ] == 0 ) {
                arr[ v.first ][ v.second - 1 ] = 1;
                s++;
                que.push( { v.first, v.second - 1 } );
            };

            if ( arr[ v.first + 1 ][ v.second ] == 1 )
                arr[ v.first ][ v.second + 1 ] = -1;
            if ( arr[ v.first ][ v.second + 1 ] == 1 )
                arr[ v.first + 1 ][ v.second ] = -1;
            if ( arr[ v.first - 1 ][ v.second ] == 1 )
                arr[ v.first ][ v.second - 1 ] = -1;
            if ( arr[ v.first ][ v.second - 1 ] == 1 )
                arr[ v.first - 1 ][ v.second ] = -1;

        }

        if ( s >= way_size ) {
            gen_quest('!');
            return 0;
        }

    }


    return 0;
}
