fun main() {
	val n = readLine()!!.toInt()
	for (y in n - 1 downTo 2) {
		for (x in n - 1 downTo 0) {
			for (j in 0..y - 2) {
				for (i in n - 2 downTo 0) {
					putMax(i, j, 0)
				}
			}
			for (i in 0 until x) {
				putMax(i, y - 1, 1)
			}
			if (x > 0) continue
			putMax(0, y - 1, 0)
			putMax(0, y - 2, 0)
			putMax(0, y - 1, 1)
		}
	}
}

private fun putMax(xSquare: Int, ySquare: Int, xMax: Int, yMax: Int = 1) {
	var (xTested, yTested) = xMax to yMax
	repeat(3) {
		val t = yTested; yTested = 1 - xTested; xTested = t
		conditionalRotate(xSquare, ySquare, xTested, yTested, xMax, yMax)
	}
}

private fun conditionalRotate(xSquare: Int, ySquare: Int, x1: Int, y1: Int, x2: Int, y2: Int) {
	println("${cell(xSquare + x1, ySquare + y1)} > ${cell(xSquare + x2, ySquare + y2)} ? ${cell(xSquare, ySquare)}")
}

private fun cell(x: Int, y: Int) = "${('a' + x)}${1 + y}"
