#include <bits/stdc++.h>
#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("sse,sse2,sse3,sse4,avx,avx2,tune=native")

using namespace std;

const int N = 500;

bitset <N> ans[N][N];
vector <int> g[N];
bitset <N> pth[N];
int tin[N], tout[N];
int who[N];
int lca[N][N];

int tt = 0;

void dfs(int v, int pr) {
	tin[v] = tt++;
	who[tin[v]] = v;
	for (int to : g[v]) {
		if (to != pr) {
			dfs(to, v);
		}
	}
	tout[v] = tt;
	for (int i = tin[v]; i < tout[v]; i++) {
		int a = who[i];
		pth[a][v] = 1;
		for (int j = tin[v]; j < tout[v]; j++) {
			int b = who[j];
			if (lca[a][b] == -1) {
				lca[a][b] = v;
			}
		}
	}
}

mt19937 rnd(228);

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	int n = 500, k = 500;
	//cin >> n >> k;
	for (int i = 0; i < n; i++) {
		for (int j = i + 1; j < n; j++) {
			for (int k = 0; k < n; k++) {
				ans[i][j][k] = 1;
			}
		}
	}
	for (int i = 0; i < k; i++) {
		tt = 0;
		for (int i = 0; i < n; i++) {
			g[i].clear();
			pth[i].reset();
		}
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < n; j++) {
				lca[i][j] = -1;
			}
		}
		for (int i = 1; i < n; i++) {
			int a = rnd() %  i, b = i;
			/*
			cin >> a >> b;
			a--, b--;
			*/
			g[a].push_back(b);
			g[b].push_back(a);
		}
		dfs(0, -1);
		for (int i = 0; i < n; i++) {
			for (int j = i + 1; j < n; j++) {
				auto cur = (pth[i] ^ pth[j]);
				cur[lca[i][j]] = 1;
				ans[i][j] &= cur;
			}
		}
	}
	cout << clock() / (double) CLOCKS_PER_SEC << endl;
	return 0;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			if (i == j) {
				cout << 1 << ' ';
			} else {
				cout << ans[min(i, j)][max(i, j)].count() << ' ';
			}
		}
		cout << '\n';
	}
}
