#include <bits/stdc++.h>

using namespace std;

const int N = 2000 + 7;

vector <int> g[N];

int sz = 0;

int id[N][N];
pair <int, int> ok[N];

int par[N];

int get(int v) {
	if (v == par[v]) {
		return v;
	} else {
		return par[v] = get(par[v]);
	}
}

void uni(int u, int v) {
	par[get(u)] = get(v);
}

int odd[N];
bool u[N];

int cur = 0;

vector <pair <int, int> > ed;

int dfs(int v, int pr = -1) {
	u[v] = 1;
	int cur = odd[v];
	for (int to : g[v]) {
		if (!u[to]) {
			cur ^= dfs(to, v);
		}
	}
	if (cur) {
		ed.push_back({v, pr});
		return 1;
	} else {
		return 0;
	}
}

set <int> gr[N];

vector <pair <int, int> > ans;

void euler(int v) {
	while (gr[v].size() > 0) {
		int u = *gr[v].begin();
		gr[u].erase(v);
		gr[v].erase(u);
		euler(u);
	}
	ans.push_back(ok[v]);
}

mt19937 rnd(228);

int main() {
	int n, m;
	cin >> n >> m;
	vector <string> s(n);
	for (int i = 0; i < n; i++) {
		cin >> s[i];
	}
	for (int i = 0; i < 2 * n; i++)
		for (int j = 0; j < 2 * m; j++)
			id[i][j] = -1;
	auto k = [&] (int u, int v) {
		if (id[u][v] != -1) {
			return id[u][v];
		}
		id[u][v] = sz++;
		ok[id[u][v]] = {u, v};
		return id[u][v];
	};
	set <pair <int, int> > q;
	auto add_edge = [&] (int u, int v) {
		if (u > v) swap(u, v);
		q.insert({u, v});
	};
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			if (s[i][j] == '*') {
				int a = k(i, j);
				int b = k(i, j + 1);
				int c = k(i + 1, j + 1);
				int d = k(i + 1, j + 0);
				add_edge(a, b);
				add_edge(b, c);
				add_edge(c, d);
				add_edge(d, a);
			}
		}
	}
	while (true) {
		if (clock() / (double) CLOCKS_PER_SEC >= 1.9) {
			cout << "No\n";
			return 0;
		}
		vector <pair <int, int> > e;
		for (auto c : q) {
			e.push_back(c);
		}
		shuffle(e.begin(), e.end(), rnd);
		for (int i = 0; i < sz; i++) {
			par[i] = i;
			odd[i] = 0;
		}
		vector <pair <int, int> > f;
		ed.clear();
		for (auto c : e) {
			int u = c.first, v = c.second;
			if (get(u) != get(v)) {
				ed.push_back(c);
				odd[u] ^= 1, odd[v] ^= 1;
				uni(u, v);
			} else {
				f.push_back(c);
			}
		}
		for (int i = 0; i < sz; i++) g[i].clear(), u[i] = 0;
		for (auto c : f) {
			g[c.first].push_back(c.second);
			g[c.second].push_back(c.first);
		}
		bool bad = false;
		for (int i = 0; i < sz; i++) {
			if (!u[i]) {
				if (dfs(i)) {
					bad = true;
					break;
				}
			}
		}
		if (bad) {
			continue;
		}
		for (auto c : ed) {
			gr[c.first].insert(c.second);
			gr[c.second].insert(c.first);
		}
		euler(0);
		cout << "Yes\n";
		ans.pop_back();
		cout << ans.size() << endl;
		for (auto c : ans) {
			cout << c.first << ' ' << c.second << '\n';
		}
		return 0;
	}
}
