#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <set>
#include <map>
#include <vector>
#include <cmath>
#include <iomanip>
#include <string>
#include <algorithm>

using namespace std;

inline void input() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cin.tie(NULL);
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif _DEBUG
}

typedef long long ll;
typedef long double dbl;
const int INF = (int)1e9;
const dbl EPS = 1e-9;

int main() {
	input();
	int n;
	cin >> n;
	for (int j = 0; j < n; j++) {
		vector <pair<dbl, dbl> > arr(4);
		for (int i = 0; i < 4; i++) {
			cin >> arr[i].first >> arr[i].second;
		}
		dbl a0, b0;
		cin >> b0 >> a0;
		b0 = -b0;
		dbl x0 = a0, y0 = -b0;
		dbl a1 = (arr[0].second - arr[1].second), b1 = (arr[1].first - arr[0].first);
		dbl c1 = a1 * (-arr[1].first) + b1 * (-arr[1].second);
		dbl a2 = (arr[2].second - arr[3].second), b2 = (arr[3].first - arr[2].first);
		dbl c2 = a2 * (-arr[3].first) + b2 * (-arr[3].second);
		bool flag = false;
		for (int i = 0; i < 2; i++) {
			dbl c = -(a0 * arr[i].first + b0 * arr[i].second);
			if (a2 * b0 - b2 * a0 == 0) {
				dbl y = (-c1 * a2 + a1 * c2) / (a2 * b1 - b2 * a1);
				dbl x = (-c2 - b2 * y) / a2;
				if (!(arr[0].first < x && arr[1].first < x || arr[1].first > x && arr[0].first > x
					|| arr[1].second > y && arr[0].second > y || arr[1].second < y && arr[0].second < y)) {
					if (x0 * (x - arr[2].first) <= 0 && y0 * (y - arr[2].second) <= 0)
						flag = true;
				}
			}
			else {
				dbl y = (-c * a2 + a0 * c2) / (a2 * b0 - b2 * a0);
				dbl x = (-c2 - b2 * y) / a2;
				if (!(arr[2].first < x && arr[3].first < x || arr[3].first > x && arr[2].first > x
					|| arr[3].second > y && arr[2].second > y || arr[3].second < y && arr[2].second < y)) {
					if (x0 * (x - arr[i].first) >= 0 && y0 * (y - arr[i].second) >= 0)
						flag = true;
				}
			}
		}
		if (flag) {
			cout << "Yes\n";
		}
		else {
			cout << "No\n";
		}
	}
}
