#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <iomanip>
#include <set>
#include <algorithm>
#include  <map>
#include  <numeric>
#include <random>
#include <list>
#include <cassert>

#pragma warning(disable : 4996)
using namespace std;

#define all(a) (a).begin(), (a).end()
#define nl '\n'

typedef long long ll;

const ll LINF = numeric_limits<ll>::max();
const int INF = numeric_limits<int>::max();

inline void IO() {
#ifdef _DIVAN
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
}

//const int ML = 536070912;
//char memo[ML];
//int ptr = 0;
//
//void* operator new(size_t n) {
//	ptr += n;
//	assert(ptr < ML);
//	return memo + ptr - n;
//}
//
//
//void operator delete(void*) {};

struct Sq {
	int x1, y1, x2, y2;
	string pref;
	string suf;

	bool operator < (const Sq& a) const {
		return x1 < a.x1;
	}
};

int getM(int a, int b) {
	return (a + b) / 2;
}

void build(const Sq& sq, string& s) {

	int md = getM(sq.x1, sq.x2);
	for (int i = (int)sq.pref.size() - 1; i >= 0; i--) {
		s += sq.pref[i];
	}
	for (int i = sq.x1; i < md; i++)
		s += 'D';
	for (int i = sq.y1; i < sq.y2; i++)
		s += 'R';
	for (int i = md; i < sq.x2; i++)
		s += 'D';

	s += sq.suf;
}

const int N = 3000;
pair<int, int> ans[N];

inline void solve() {
	int n, m;
	cin >> m >> n;
	string s;
	list<Sq> v;
	v.push_back({ 1, 1, m, n });
	for (int q = 0; q < 10; q++) {
		s.clear();
		for (auto it = v.begin(); it != v.end(); it++) {
			build(*it, s);
		}
		cout << "? " << s << endl;

		int t;
		cin >> t;
		for (int i = 0; i < t; i++) {
			cin >> ans[i].first >> ans[i].second;
		}

		if (t == n + m - 1) {
			break;
		}

		int i = 0;
		for (auto it = v.begin(); it != v.end(); it++) {

			if (it->x1 == it->x2 || it->y1 == it->y2)
				continue;

			int md = getM(it->x1, it->x2);

			//if (binary_search(ans, ans + t, pair<int, int> {it->x1 + 1, it->y1})) {
			//	if (it->x1 != it->x2) {
			//		it->pref += 'D';
			//		it->x1++;
			//	}
			//}
			//else {
			//	if (it->y1 != it->y2) {
			//		it->pref += 'R';
			//		it->y1++;
			//	}
			//}

			//if (binary_search(ans, ans + t, pair<int, int> {it->x2 - 1, it->y2})) {
			//	if (it->x1 != it->x2) {
			//		it->suf += 'D';
			//		it->x2--;
			//	}
			//}
			//else {
			//	if (it->y1 != it->y2) {
			//		it->suf += 'R';
			//		it->y2--;
			//	}
			//}

			if (it->x1 == it->x2 || it->y1 == it->y2)
				continue;

			auto it1 = lower_bound(ans, ans + t, pair<int, int> {md, 0});
			auto it2 = upper_bound(ans, ans + t, pair<int, int> {md, INF});
			int k = it2 - it1;

			int p1x = it1->first - 1;
			int p1y = it1->second;
			int p2x = it1->first + 1;
			int p2y = it1->second + k - 1;

			Sq sq2 = { p2x, p2y, it->x2, it->y2, "", it->suf };
			*it = { it->x1, it->y1, p1x, p1y, it->pref, "D" };
			for (int i = 1; i < k; i++) {
				it->suf += 'R';
			}
			if (it1->first != p2x) {
				it->suf += 'D';
			}
			v.insert(next(it), sq2);
			it++;
		}
	}
	cout << "! " << s << endl;
}

int main() {
	//IO();

	//int t;
	//cin >> t;
	//while (t--) {
	solve();
	//}
	return 0;
}