#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <map>
#include <vector>
#include <algorithm>

using namespace std;
#define ll long long
#define ld long double
#define fs first
#define sc second
const ld eps = 1e-9;
const ll INF = 1e18;

const ld pi = acosl(-1);

struct pt {
	ld x, y;

	pt operator+(pt& v) {
		return { x + v.x, y + v.y };
	}

	pt operator-(pt& v) {
		return { x - v.x, y - v.y };
	}

	ld cross(pt v) {
		return x * v.y - y * v.x;
	}

	ld ang() {
		return atan2(y, x);
	}
};

pt a1, b1, a2, b2, v;

int f1(ld x) {
	ld k = (x - a1.x) / (b1.x - a1.x);
	ld y = k * (b1.y - a1.y) + a1.y;
	
	ld v1 = v.cross({ b1.x - x, b1.y - y });
	ld v2 = v.cross({ b2.x - x, b2.y - y });
	if (v1 < eps && v2 > -eps) return 0;
	if (v2 < eps && v1 >- eps) return 0;
	

}

bool f2(ld y) {
	return false;
}

ll l, r, n, cnt = 0;



void pr(ll a, ll b, ll c, ll n) {
	bool d = 1;
	cout << a << "^" << n << "+" << b << "^" << n << (d ? ">" : "<") << c << "^" << n << "\n";
}

void rq(vector<int> a) {
	if (a.size() == 3) {
		cnt++;
		pr(a[0], a[1], a[2], n);
		return;

	}
	for (int i = 1; i <= n; ++i) {
		a.push_back(i);
		rq(a);
		a.pop_back();
	}
}


bool ifin(ld l, ld r, ld m) {
	if (l <= r) return l <= m && m <= r;
	return m <= r || l <= m;
}

pair<ll, int> d[9]; 
pair<ll, int> nd[9];
vector<pair<int, int>> anss[9];

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
#ifndef ONLINE_JUDGE
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif










	/*
	int n, m;
	cin >> n >> m;
	for (int i = 0; i < 9; i++)
	{
		d[i].fs = INF;
		d[i].sc = i;
	}
	
	d[n % 9].fs = n;
	int id = m % 9;

	for (int j = 0; j < 1000; j++)
	{
		if (d[id].fs <= m)
		{
			int p = ((m - d[id].fs) / 9);
			if (p > 0)
			{
				anss[d[id].sc].push_back({0, p});
			}
			int all = (anss[d[id].sc]).size();
			if (all <= 1000)
			{
				cout << "Stable" << endl;
				cout << all << endl;
				for (auto a : anss[d[id].sc])
				{
					if (a.fs == 0) cout << "+ ";
					else cout << "- ";
					cout << a.sc <<"aa" << endl;
				}
				return 0;
			}
		}
		for (int i = 0; i < 9; i++)
		{
			int oo = 0;
			int ooo = 1;
			for (int o = 1; o < 9; o++)
			{
				oo = oo * 10 + 1;
				ooo *= 10;
				int b = (d[i].fs % ooo - oo + oo*9) % 9;
				int ni = (i - o + 9) % 9;
				if (b == 0)
				{
					int k = 0;
					if (anss[d[i].sc].size() > 0)
					{
						k = anss[d[i].sc].back().sc;
						anss[d[i].sc].pop_back();
					}
					anss[d[i].sc].push_back({ 1, k + 1 });
				}
				else
				{
					anss[d[i].sc].push_back({ 0, b });
					anss[d[i].sc].push_back({ 1, o });
				}
				int ls = anss[d[ni].sc].size();
				int ns = anss[d[i].sc].size();

				int nf = (d[i].fs + 9 * b) / 10;
				if (d[ni].fs > nf || d[ni].fs == nf && ls > ns)
				{
					nd[ni] = make_pair(nf, d[i].sc);
				}
			}
		}
		swap(d, nd);
	}*/

	int n;
	cin >> n;
	for (int i = 0; i < n; ++i) {

		cin >> a1.x >> a1.y;
		cin >> b1.x >> b1.y;
		cin >> a2.x >> a2.y;
		cin >> b2.x >> b2.y;
		cin >> v.x >> v.y;

		vector<pair<ld, ld> > ans;

		ld l1, r1, m1, l2, r2, m2, l3, r3, lm, rm;
		l1 = (a2 - a1).ang();
		r1 = (b2 - a1).ang();
		m1 = (a2 - a1 + b2 - a1).ang();
		if (l1 >= r1) swap(l1, r1);
		if (l1 <= m1 && m1 <= r1) ans.push_back({ l1,r1 });
		else {
			ans.push_back({ -pi, l1 });
			ans.push_back({ r1,pi });
		}

		l2 = (a2 - b1).ang();
		r2 = (b2 - b1).ang();
		m2 = (a2 - b1 + b2 - b1).ang();
		if (l2 >= r2) swap(l2, r2);
		if (l2 <= m2 && m2 <= r2) ans.push_back({ l2,r2 });
		else {
			ans.push_back({ -pi, l2 });
			ans.push_back({ r2,pi });
		}

		l3 = (a2 + a2 - a1 - b1).ang();
		r3 = (b2 + b2 - a1 - b1).ang();
		if (l3 >= r3) swap(l3, r3);
		
		
		if (!ifin(l1, l2, l3)) swap(l1, l2);

		if (l1 <= l2) ans.push_back({ l1,l2 });
		else {
			ans.push_back({ l2,pi });
			ans.push_back({ -pi, l1 });
		}
		if (!ifin(r1, r2, r3)) swap(r1, r2);

		if (r1 <= r2) ans.push_back({ r1,r2 });
		else {
			ans.push_back({ r2,pi });
			ans.push_back({ -pi, r1 });
		}
		ld vang = v.ang();
		bool f = 0;
		for (auto i : ans) {
			if (i.fs - eps <= vang && vang <= i.sc + eps) {
				f = 1;
			}
		}
		if (f) cout << "Yes\n";
		else cout << "No\n";
	}
}