#include<bits/stdc++.h>
//#define int long long

using namespace std;

struct Point{
    int x, y;
    Point(int x1 = 0, int y1 = 0){
        x = x1;
        y = y1;
    }

    void input(){
        cin >> x >> y;
    }

    void outout(){
        cout << x << ' ' << y << endl;
    }
};

struct Vector{
    int x, y;
    Vector(Point a = Point(), Point b = Point()){
        x = b.x - a.x;
        y = b.y - a.y;
    }

    void input(){
        cin >> x >> y;
    }

    int cross_product(Vector v){
        return x * v.y - y * v.x;
    }

    int dot_product(Vector v){
        return x * v.x + y * v.y;
    }
};

int check(Point a, Point b, Point c, Vector v){
    Vector f(a, b), s(a, c);
    int t1 = v.cross_product(f), t2 = v.cross_product(s), t3 = v.dot_product(f), t4 = v.dot_product(s);
    /*
    cout << "The first point: ";
    a.outout();
    cout << "The second point: ";
    b.outout();
    cout << "The third point: ";
    c.outout();
    cout << "Productions: " << t1 << ' ' << t2 << endl;
    cout << "----End----" << endl;
    */
    if(t3 < 0 || t4 < 0)
        return 2;
    if(t1 == 0 || t2 == 0)
        return 0;
    if(t1 >= 0){
        if(t2 >= 0)
            return 1;
        return 0;
    }
    if(t2 <= 0)
        return -1;
    return 0;
}

void solve() {
    Point a, b, c, d;
    Vector v;
    a.input();
    b.input();
    c.input();
    d.input();
    v.input();
    Vector q(a,c), w(a, d), e(b, c), r(b, d);
    double minn = 10, maxx = -10;
//    double minn = 10, maxx = -10;
    minn = min(minn, atan2(q.x, q.y));
    minn = min(minn, atan2(w.x, w.y));
    minn = min(minn, atan2(e.x, e.y));
    minn = min(minn, atan2(r.x, r.y));
    maxx = max(maxx, atan2(q.x, q.y));
    maxx = max(maxx, atan2(w.x, w.y));
    maxx = max(maxx, atan2(e.x, e.y));
    maxx = max(maxx, atan2(r.x, r.y));
    //cout << minn << ' ' << maxx << endl;
    long double k = atan2(v.x, v.y);
    //cout << k << endl;
    if(k >= minn && k <= maxx){
        cout << "Yes\n";
    }
    else{
        cout << "No\n";
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
/*
1
0 0 10 10 4 3 5 3 -1 0
*/
