from math import atan2, pi

EPS = 10 ** (-8)


def plus(a, b):
    return [a[0] + b[0], a[1] + b[1]]


def minus(a, b):
    return [a[0] - b[0], a[1] - b[1]]


def angle(a, b, c):
    aprime = minus(a, b)
    cprime = minus(c, b)
    if abs(atan2(aprime[1], aprime[0]) - atan2(cprime[1], cprime[0])) - pi > EPS:
        return 2 * pi - abs(atan2(aprime[1], aprime[0]) - atan2(cprime[1], cprime[0]))
    else:
        return abs(atan2(aprime[1], aprime[0]) - atan2(cprime[1], cprime[0]))


def dot(a, b):
    return a[0] * b[0] + a[1] * b[1]


def cross(a, b):
    return a[0] * b[1] - a[1] * b[0]


def check(a, b, c, d):
    angle1 = angle(a, b, c)
    angle2 = angle(a, b, d)
    angle3 = angle(c, b, d)
    return abs(angle2 + angle3 - angle1) <= EPS


def f():
    ax1, ay1, ax2, ay2, bx1, by1, bx2, by2, vx, vy = map(int, input().split())
    a1 = [ax1, ay1]
    a2 = [ax2, ay2]
    b1 = [bx1, by1]
    b2 = [bx2, by2]
    v = [vx, vy]
    v2 = [-vx, -vy]
    na1 = plus(a1, v)
    na2 = plus(a2, v)
    nb1 = plus(b1, v2)
    nb2 = plus(b2, v2)
    if (check(a1, a2, na2, b1) and check(a2, a1, na1, b1) or check(a1, a2, na2, b2) and check(a2, a1, na1, b2)) or \
            (check(b1, b2, nb2, a1) and check(b2, b1, nb1, a1) or check(b1, b2, nb2, a2) and check(b2, b1, nb1, a2)):
        print('Yes')
    else:
        print('No')


for i in range(int(input())):
    f()
