#ifdef _DEV
#define DEV 1
#else
#define DEV 0
#endif

#include <bits/stdc++.h>

using namespace std;

void rmain(int test_id);

int main() {
    int tests = 1;
    if (DEV) {
        tests = 1000;
        // freopen("input.txt", "r", stdin);
    } else {
        ios::sync_with_stdio(false);
        cin.tie(nullptr);
        cout << fixed << setprecision(15);
    }
    for (int t = 0; t < tests; ++t) {
        rmain(t);
        int ch = -1;
        while (DEV) {
            ch = getc(stdin);
            if (ch == -1 || !isspace(ch)) {
                break;
            }
        }
        if (ch == -1) {
            break;
        }
        ungetc(ch, stdin);
    }

    return 0;
}

using ll = long long;
using xld = __float128;

using pzz = pair<size_t, size_t>;

void rmain(int test_id) {
    (void) test_id;
    size_t n, m;
    cin >> n >> m;
    vector<size_t> col_begin(n, 0), col_end(n, m);
    //col_end[0] = 1;
    //col_begin[n - 1] = m - 1;
    vector<pzz> known;
    known.emplace_back(0, 0);
    known.emplace_back(n - 1, m - 1);
    size_t const total_path_len = n + m - 1;
    while (known.size() < total_path_len) {
        vector<pzz> guess;
        guess.emplace_back(0, 0);
        size_t k = known.size();
        for (size_t i = 0; i < k - 1; ++i) {
            size_t cy = known[i].second;
            if (known[i].first != known[i + 1].first) {
                for (size_t cx = known[i].first + 1; cx <= known[i + 1].first; ++cx) {
                    size_t target = (col_begin[cx] + col_end[cx]+1) / 2;
                    target = min(target, known[i + 1].second);
                    while (cy < target) {
                        guess.emplace_back(cx - 1, ++cy);
                    }
                    guess.emplace_back(cx, cy);
                }
            }
            while (cy < known[i + 1].second) {
                guess.emplace_back(known[i + 1].first, ++cy);
            }

        }
        if (DEV) {
            for (auto[f1, f2] : guess) {
                printf("| %zu %zu\n", f1, f2);
            }
        }
        assert(guess.size() == total_path_len);
        cout << "? ";
        map<pzz, size_t> pos_in_guess;
        for (size_t i = 1; i < total_path_len; ++i) {
            if (guess[i].first == guess[i - 1].first) {
                cout << 'R';
            } else {
                cout << 'D';
            }
            pos_in_guess[guess[i]] = i;
        }
        cout << endl;
        size_t sz;
        cin >> sz;
        vector<pzz> nkn;
        //known.clear();
        for (size_t i = 0; i < sz; ++i) {
            size_t x, y;
            cin >> x >> y;
            --x;
            --y;
            nkn.emplace_back(x, y);
        }
        for (size_t i = 0; i < nkn.size() - 1; ++i) {
            if (nkn[i].first == nkn[i + 1].first) {
                continue;
            }
            size_t const p1 = pos_in_guess[nkn[i]];
            size_t const p2 = p1 + 1;
            size_t const p3 = pos_in_guess[nkn[i + 1]];
            if (guess[p1].first == guess[p2].first) {
                for (size_t j = p2; j < p3; ++j) {
                    col_begin[guess[j].second] = max(col_begin[guess[j].second], guess[j].first + 1);
                }
            } else {
                for (size_t j = p2; j < p3; ++j) {
                    col_end[guess[j].second] = min(col_end[guess[j].second], guess[j].first);
                }
            }

        }
        known = nkn;
    }
    cout << "! ";
    for (size_t i = 1; i < total_path_len; ++i) {
        if (known[i].first == known[i - 1].first) {
            cout << 'R';
        } else {
            cout << 'D';
        }
    }
    cout << endl;
}