#ifdef _DEV
#define DEV 1
#else
#define DEV 0
#endif

#include <bits/stdc++.h>

using namespace std;

void rmain(int test_id);

int main() {
    int tests = 1;
    if (DEV) {
        tests = 1000;
        freopen("input.txt", "r", stdin);
    } else {
        ios::sync_with_stdio(false);
        cin.tie(nullptr);
        cout << fixed << setprecision(15);
    }
    for (int t = 0; t < tests; ++t) {
        rmain(t);
        int ch = -1;
        while (DEV) {
            ch = getc(stdin);
            if (ch == -1 || !isspace(ch)) {
                break;
            }
        }
        if (ch == -1) {
            break;
        }
        ungetc(ch, stdin);
    }

    return 0;
}

using ll = long long;

int strip(string s) {
    while (s.size() > 1 && s[0] == '0') {
        s = s.substr(1);
    }
    return atoi(s.c_str());
}

string pad(int x, int w) {
    ostringstream oss;
    oss << x;
    string s = oss.str();
    while (s.size() < w) {
        s = "0" + s;
    }
    return s;
}

void rmain(int test_id) {
    (void) test_id;
    size_t k;
    cin >> k;
    for (size_t i = 0; i < k; ++i) {
        string s;
        cin >> s;
        bool is_us = false;
        for (char c : s) {
            if (c == '/') { is_us = true; }
        }
        for (char& c : s) {
            if (c == '.' || c == '/') {c = ' ';}
        }
        istringstream iss(s);
        string _x, _y, _z;
        iss >> _x >> _y >> _z;
        int x, y, z;
        x = strip(_x);
        y= strip(_y);
        z = strip(_z);
        //int a, b, c;
        //a = x;
        if (is_us) {
            swap(x, y);
        }
        {
            cout << pad(x, 2) << '.' << pad(y, 2) << '.' << pad(z, 4) << " ";
        }
        //swap(x, y);
        {
            cout << pad(y, 2) << '/' << pad(x, 2) << '/' << pad(z, 4) << "\n";
        }
    }
}