#include<iostream>
#include<vector>
#include<string>
#include<cstdio>
#include<algorithm>
#include<bitset>
#include<stack>
#include<queue>
#include<iomanip>
#include<cassert>
#include<map>
#include<set>
#include<cmath>
using namespace std;

#define fastio ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0)
#define int long long
#define forn(i, n) for(int i = 0; i < n; i++)
#define fs first
#define sc second
#define pb push_back
#define MP make_pair
#define FR(i, n) for(int i = 0; i < n; i++)
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define endl '\n'
#define double long double

const double eps = 1e-7;

struct vec {
	int x;
	int y;
	vec() {}
	vec(int _x, int _y) {
		x = _x;
		y = _y;
	}
};

vec operator +(vec& a, vec& b) {
	return { a.x + b.x, a.y + b.y };
}
vec operator -(vec& a, vec& b) {
	return { a.x - b.x, a.y - b.y };
}
struct line {
	int a;
	int b;
	int c;
	line(vec& a, vec& son) {
		vec b = { a.x + son.x, a.y + son.y };
		this->a = b.y - a.y;
		this->b = a.x - b.x;
		this->c = a.y * b.x - a.x * b.y;
	}
	/*line(vec& a, vec& son) {
		this->a = son.y;
		this->b = -son.x;
		this->c = son.x * a.y - son.y * a.x;
	}*/
};

double dist(line& l, vec& pt) {
	return 1.0 * abs(l.a * pt.x + l.b * pt.y + l.c) / sqrt(l.a * l.a + l.b * l.b);
}

double dist(vec& a, vec& b) {
	return sqrt((a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y));
}

istream& operator >>(istream& in, vec& p) {
	in >> p.x >> p.y;
	return in;
}

int operator ^(vec& a, vec& b) {
	return a.x * b.y - a.y * b.x;
}
signed main() {
	fastio;

	int q;
	cin >> q;
	while (q--) {
		vec a, b, c, d, son;
		cin >> a >> b >> c >> d >> son;
		double dd = dist(c, d);
		line l1(c, son), l2(d, son);
		vec c1 = { c.x + son.x, c.y + son.y };
		vec d1 = { d.x + son.x, d.y + son.y };
		vec cd = c1 - d;
		vec dc = d1 - c;
		vec ac = a - c;
		vec ad = a - d;
		vec bc = b - c;
		vec bd = b - d;
		bool ok1 = ((cd ^ son) * (ac ^ ad)) >= 0;
		bool ok2 = ((cd ^ son) * (bc ^ bd)) >= 0;
		if (abs(dist(l1, a) + dist(l2, a) - dd) < eps && ok1 ||
			abs(dist(l1, b) + dist(l2, b) - dd) < eps && ok2)
			cout << "YES\n";
		else cout << "NO\n";
	}
}