#include <bits/stdc++.h>

//#define _FORTIFY_SOURCE 0
//#pragma GCC optimize("0fast")
//#pragma GCC optimize("no-stack-protector")
//#pragme GCC optimize ("unroll-loops")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm, mmx,tune=native")

#define ull unsigned long long
#define ll long long
#define pll pair<ll, ll>
#define mp make_pair
#define ld long double
#define pb push_back
#define all(x) x.begin(), x.end()
#define deb(x) cout << #x << " = "<< x << endl;

const ll mod1 = 1e9+7;
const ll mod2 = 948735481;
const ll P1 = 678463;
const ll P2 = 239;
const ll inf = (ll)1e18;
const long double MATH_E = 2.718281828459;
const long double eps = 1e-15;
const long double MATH_PI = atan2l(0, -1);


using namespace std;


vector<vector<ll>> get_all(ll mx) {
    vector<vector<ll>> ans;
    for (int i = 1; i <= mx; i++) {
        for (int j = 1; j <= mx; j++) {
            for (int k = 1; k <= mx; k++) {
                if (k > 2) {
                    ans.pb({mx, i, j, k});
                }
                if (i < mx and k > 2) {
                    ans.pb({i, mx, j, k});
                }
                if (i < mx and j < mx and k > 2) {
                    ans.pb({i, j, mx, k});
                }
                if (i < mx and j < mx and k < mx) {
                    ans.pb({i, j, k, mx});
                }
            }
        }
    }
    sort(all(ans));
    return ans;
}


void print(vector<ll> la) {
    cout << la[0] << "^" << la[3] << "+" << la[1] << "^" << la[3];
    if (la[2] > max(la[0], la[1])) {
        //assert(pw(la.a, la.n) + pw(la.b, la.n) < pw(la.c, la.n));
        cout << "<";
    } else {
        //assert(pw(la.a, la.n) + pw(la.b, la.n) > pw(la.c, la.n));
        cout << ">";
    }
    cout << la[2] << "^" << la[3] << "\n";
}


ll get_colvo(ll x) {
    return x * x * (x - 2) + (x - 1) * (x - 2) * x + (x - 1) * (x - 1) * (x - 2) + (x - 1) * (x - 1) * (x - 1);
}

void solve() {
    ll l, r;
    cin >> l >> r;
    ll lcur = l;
    ll mxl = 3;
    while (lcur > get_colvo(mxl)) {
        lcur -= get_colvo(mxl);
        mxl++;
    }
    ll rcur = r;
    ll mxr = 3;
    while (rcur > get_colvo(mxr)) {
        rcur -= get_colvo(mxr);
        mxr++;
    }
    auto la = get_all(mxl), ra = get_all(mxr);
    if (mxl != mxr) {
        for (ll i = lcur - 1; i < la.size(); i++) {
            print(la[i]);
        }
        for (ll i = mxl + 1; i < mxr; i++) {
            auto temp = get_all(i);
            for (auto p : temp) {
                print(p);
            }
        }
        for (ll i = 0; i < rcur; i++) {
            print(ra[i]);
        }
    } else {
        for (ll i = lcur - 1; i < rcur; i++) {
            print(la[i]);
        }
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    cout.precision(30);
    cout.setf(ios::fixed);
    solve();
    return 0;
}