#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
using namespace std;

int ar[2000][2000];

struct pt
{
	int a, b, c, d;
	pt() {};
	pt(int a, int b, int c, int d) : a(a), b(b), c(c), d(d) {};
	bool operator<(const pt x) const {
		return x.a < a;
	}
};

int main() {

	int n, m;
	cin >> n >> m;
	set <pt> s;
	s.insert(pt(0, 0, n - 1, m - 1));
	while (s.size()) {
		int a = 0, b = 0;
		cout << "? ";
		for (auto& i : s) {
			for (a; a < i.a; ++a) {
				cout << "D";
			}
			for (b; b < i.b; ++b) {
				cout << "R";
			}
			int md = (i.a + i.c) / 2;
			for (a; a < md; ++a) {
				cout << "D";
			}
			for (b; b < i.d; ++b) {
				cout << "R";
			}
			for (a; a < i.c; ++a) {
				cout << "D";
			}
		}
		cout << endl;
		int k;
		cin >> k;
		vector <pt> v(k);
		for (int i = 0; i < k; ++i) {
			cin >> v[i].a >> v[i].b;
			v[i].a--;
			v[i].b--;
		}
		int j = 0;
		for (auto it = s.begin(); it != s.end();) {
			pt i = (*it);
			for (j; v[j].a < i.a; ++j);
			int md = (i.a + i.c) / 2, f1 = 0, f2 = 0, f3 = 0;
			int x[4], y[4];
			for (j; v[j].a < md; ++j) {
				f1 = 1;
				ar[v[j].a][v[j].b] = 1;
			}
			if (f1) {
				x[0] = v[j - 1].a;
				y[0] = v[j - 1].b + 1;
			}
			for (j; v[j].a == md; ++j) {
				if (f1) {
					if (v[j].a - 1 - x[0] > 0 && v[j].b - y[0]) {
						x[1] = v[j].a - 1;
						y[1] = v[j].b;
					}
					else {
						for (int i1 = x[0]; i1 <= v[j].a - 1; ++i1) {
							for (int j1 = y[0]; j1 <= v[j].b; ++j1) {
								ar[i1][j1] = 1;
							}
						}
						x[1] = -1;
					}
					f1 = 0;
				}
				ar[v[j].a][v[j].b] = 1;
				x[2] = v[j].a + 1;
				y[2] = v[j].b;
			}

			if (v[j].a - x[2] > 0 && v[j].b - 1 - y[2]) {
				x[3] = v[j].a;
				y[3] = v[j].b - 1;
			}
			else {
				for (int i1 = x[2]; i1 <= v[j].a; ++i1) {
					for (int j1 = y[2]; j1 <= v[j].b - 1; ++j1) {
						ar[i1][j1] = 1;
					}
				}
				x[3] = -1;
			}
			for (j; v[j].a < i.c; ++j) {
				f3 = 1;
				ar[v[j].a][v[j].b] = 1;
			}
			ar[v.back().a][v.back().b] = 1;
			auto it1 = it;
			it++;
			s.erase(it1);
			if (x[1] != -1) {
				s.insert(pt(x[0], y[0], x[1], y[1]));
			}
			if (x[3] != -1) {
				s.insert(pt(x[2], y[2], x[3], y[3]));
			}
		}
	}
	cout << "! ";
	int i = 0, j = 0;
	while (1) {
		if (i + 1 < n) {
			if (ar[i + 1][j] == 1) {
				i++;
				cout << "D";
			}
			else {
				j++;
				cout << "R";
			}
		}
		else if (j + 1 < m) {
			j++;
			cout << "R";
		}
		else {
			break;
		}
	}
	cout << endl;
}