#include <bits/stdc++.h>
using namespace std;

typedef long long ll;

struct Point {
    int x, y;
    Point(int _x, int _y) {
        x = _x, y = _y;
    }
    const bool operator<(Point q) const {
        return (x + y) < (q.x + q.y);
    }
};

string que;
set<Point> now, check;

string mult(string &&s, int k) {
    string res = "";
    while (k--)
        res += s;
    return res;
}

void findWay(Point beg, Point end) {
    int down = end.y - beg.y, right = end.x - beg.x;
    if (down == 1 && right == 1)
        check.insert(Point(end.x, beg.y));
    que += mult("D", down / 2) + mult("R", right) + mult("D", (down + 1) / 2);
}

int main() {
    #ifdef LOCAL
    //freopen("input", "r", stdin);
    //freopen("output", "w", stdout);
    #endif

    int h, w;
    cin >> h >> w;

    now.insert(Point(0, 0));
    now.insert(Point(w - 1, h - 1));

    int cnt = 10;

    while (cnt-- && now.size() < (h + w - 1)) {
        auto it = now.begin();
        Point prev = *it;
        it++;

        for (; it != now.end(); ++it) {
            findWay(prev, *it);
            prev = *it;
        }

        cout << "? " << que << endl;
        que.clear();

        int n;
        cin >> n;

        for (int i = 0; i < n; ++i) {
            int x, y;
            cin >> y >> x;

            now.insert(Point(x - 1, y - 1));
        }

        for (auto p: check) {
            if (now.find(p) == now.end()) {
                now.insert(Point(p.x - 1, p.y + 1));
            }
        }

        check.clear();
    }

    vector<Point> add;

    auto it = now.begin();
    Point prev = *it;
    it++;

    for (; it != now.end(); ++it) {
        if (it->x == prev.x) {
            for (int i = prev.y + 1; i < it->y; ++i)
                add.push_back(Point(prev.x, i));
        } else if (it->y == prev.y) {
            for (int i = prev.x + 1; i < it->x; ++i)
                add.push_back(Point(i, prev.y));
        }
        prev = *it;
    }

    for (auto i: add)
        now.insert(i);

    if (now.size() < (h + w - 1))
        return -1;

    cout << "! ";
    it = now.begin();
    prev = *it;
    it++;

    for (; it != now.end(); ++it) {
        if (prev.x == it->x)
            cout << "D";
        else
            cout << "R";
        prev = *it;
    }
    cout << endl;
    return 0;
}