#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/detail/standard_policies.hpp>

#define forn(i, n) for (int i = 0; i < n; ++i)

using namespace std;
using namespace __gnu_pbds;

#ifdef DEBUG
#define io freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout)
#else
#define io ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)
#endif

#define all(a) a.begin(), a.end()

typedef long long ll;
typedef long double ld;
typedef tree<
        int,
        null_type,
        less<int>,
        rb_tree_tag,
        tree_order_statistics_node_update>
        ordered_set;

struct rect {
    int ax, ay, bx, by, center;
};

void out(rect r) {
    int ctr = r.by - r.ay + 1;
    for (int i = r.ay; i < r.center; ++i) cout << 'D';
    forn(i, r.bx - r.ax) cout << 'R';
    for (int i = r.center; i < r.by; ++i) cout << 'D';
}

void cnt_center(rect &a) {
    a.center = a.ay + (a.by - a.ay) / 2;
}

int32_t main() {
    int m, n;
    cin >> m >> n;

    if (m == 1) {
        cout << "! ";
        forn(i, n - 1) cout << 'R';
        cout << endl;
        return 0;
    }
    if (n == 1) {
        cout << "! ";
        forn(i, m - 1) cout << 'D';
        cout << endl;
        return 0;
    }
    vector<vector<bool>> field(n, vector<bool>(m));
    vector<rect> rects;
    rect a;
    a.ax = 0;
    a.ay = 0;
    a.bx = n - 1;
    a.by = m - 1;
    cnt_center(a);
    field[0][0] = true;
    field[n - 1][m - 1] = true;
    rects.push_back(a);

    forn(q, 10) {
        cout << "? ";
        forn(i, rects.size()) {
            out(rects[i]);
        }
        cout << endl;
        int ctr, y, x;
        cin >> ctr;
        int ptr = 0;
        while (ptr < rects.size() && rects[ptr].ay == rects[ptr].center) ptr++;
        forn(i, ctr) {
            cin >> y >> x;
            y--, x--;
            field[x][y] = true;
            flag:;
            if (ptr >= rects.size()) continue;
            if (y < rects[ptr].center) continue;
            if (y == rects[ptr].center) {
                rect a, b, r = rects[ptr];
                a.ax = r.ax, a.ay = r.ay;
                a.bx = x, a.by = y;
                cnt_center(a);
                b.ax = x, b.ay = y;
                b.bx = r.bx, b.by = r.by;
                cnt_center(b);
                rects.erase(rects.begin() + ptr);
                rects.insert(rects.begin() + ptr, b);
                rects.insert(rects.begin() + ptr, a);
                ptr += 2;
                while (ptr < rects.size() && rects[ptr].ay == rects[ptr].center) ptr++;
                goto flag;
            }
        }
    }

    int ptr = 0;
    for (int y = 0; y + 2 < m; ++y) {
        while (!field[ptr][y + 1]) {
            field[ptr][y] = true;
            ptr++;
        }
    }
    ptr = 0;
    for (int i = 0; i < n; ++i) {
        if (field[i][m - 2]) ptr = i;
    }
    for (; ptr < n; ++ptr) field[ptr][m - 1] = true;

    cout << "! ";
    for (int y = 0; y < m; ++y) {
        for (ptr = 0; ptr + 1 < n; ++ptr) {
            if (field[ptr][y] && field[ptr + 1][y])
                cout << 'R';
        }
        if (y != m - 1) cout << 'D';
    }
    cout << endl;
}
