// ESUS POMOGI

#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

struct V {
    ll x, y;

    V(ll xx = 0, ll yy = 0) {
        x = xx, y = yy;
    }

    V(ll x1, ll y1, ll x2, ll y2) {
        x = x2 - x1, y = y2 - y1;
    }

    void operator-=(V v) {
        x -= v.x, y -= v.y;
    }

    ll operator*(V v) {
        return x * v.x + y * v.y;
    }

    ll operator^(V v) {
        return x * v.y - y * v.x;
    }

};

const ld eps = 1e-7;

void f() {
    ll ax1, ay1, ax2, ay2, bx1, by1, bx2, by2, vx, vy;
    cin >> ax1 >> ay1 >> ax2 >> ay2 >> bx1 >> by1 >> bx2 >> by2 >> vx >> vy;
    V A(ax1, ay1), B(ax2, ay2), C(bx1, by1), D(bx2, by2);
    V AC = C, BC = C, AD = D, BD = D;
    AC -= A;
    BC -= B;
    AD -= A;
    BD -= B;
    V CA = A, CB = B, DA = A, DB = B;
    CA -= C;
    CB -= C;
    DA -= D;
    DB -= D;
    V vv(vx, vy), vvv(-vx, -vy);
    ll tmp1 = AC ^ vv, tmp2 = AD ^ vv, tmp3 = AC * vv, tmp4 = AD * vv;
    ld ang1 = abs(atan2(tmp1, tmp3));
    ld ang2 = abs(atan2(tmp2, tmp4));
    ld ang3 = abs(atan2(AC ^ AD, AC * AD));
    if (((tmp1 > 0 && tmp2 < 0) || (tmp1 < 0 && tmp2 > 0) || (tmp1 == 0 && tmp3 >= 0) || (tmp2 == 0 && tmp4 >= 0)) && (tmp3 >= 0 || tmp4 >= 0) && (abs(ang1 + ang2 - ang3) <= eps)) {
        cout << "Yes\n";
        return;
    }
    tmp1 = BC ^ vv;
    tmp2 = BD ^ vv;
    tmp3 = BC * vv;
    tmp4 = BD * vv;
    ang1 = abs(atan2(tmp1, tmp3));
    ang2 = abs(atan2(tmp2, tmp4));
    ang3 = abs(atan2(BC ^ BD, BC * BD));
    if (((tmp1 > 0 && tmp2 < 0) || (tmp1 < 0 && tmp2 > 0) || (tmp1 == 0 && tmp3 >= 0) || (tmp2 == 0 && tmp4 >= 0)) && (tmp3 >= 0 || tmp4 >= 0) && (abs(ang1 + ang2 - ang3) <= eps)) {
        cout << "Yes\n";
        return;
    }
    tmp1 = CA ^ vvv;
    tmp2 = CB ^ vvv;
    tmp3 = CA * vvv;
    tmp4 = CB * vvv;
    ang1 = abs(atan2(tmp1, tmp3));
    ang2 = abs(atan2(tmp2, tmp4));
    ang3 = abs(atan2(CA ^ CB, CA * CB));
    if (((tmp1 > 0 && tmp2 < 0) || (tmp1 < 0 && tmp2 > 0) || (tmp1 == 0 && tmp3 >= 0) || (tmp2 == 0 && tmp4 >= 0)) && (tmp3 >= 0 || tmp4 >= 0) && (abs(ang1 + ang2 - ang3) <= eps)) {
        cout << "Yes\n";
        return;
    }
    tmp1 = DA ^ vvv;
    tmp2 = DB ^ vvv;
    tmp3 = DA * vvv;
    tmp4 = DB * vvv;
    ang1 = abs(atan2(tmp1, tmp3));
    ang2 = abs(atan2(tmp2, tmp4));
    ang3 = abs(atan2(DA ^ DB, DA * DB));
    if (((tmp1 > 0 && tmp2 < 0) || (tmp1 < 0 && tmp2 > 0) || (tmp1 == 0 && tmp3 >= 0) || (tmp2 == 0 && tmp4 >= 0)) && (tmp3 >= 0 || tmp4 >= 0) && (abs(ang1 + ang2 - ang3) <= eps)) {
        cout << "Yes\n";
        return;
    }
    cout << "No\n";
    return;
}

int main() {
    // freopen("input.txt", "r", stdin);
    int n;
    cin >> n;
    for (int i = 0; i < n; i++) {
        f();
    }
}
