package com.company;

import java.math.BigInteger;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

public class Main {
    static long sum(long n){
        return n * (n + 1) / 2 - 1;
    }

    static long sum_sq(long n){
        return n * (n + 1) * (2 * n + 1) / 6 - 1;
    }

    static long sum_cube(long n){
        return (n * (n + 1) / 2) * (n * (n + 1) / 2) - 1;
    }

    static long get_cnt_with_max_no_more(long max){
        if(max <= 2)
            return 0;
        return 4 * sum_cube(max - 1) + (4 - 3 * 2) * sum(max - 1) - 1;
        /// (4 * 3 / 2 - 3 * 2) * sum_sq(max - 1)
    }

    static long get_cnt(long max, long length, boolean max_appeared){
        if(length == 0){
            return max_appeared? 1 : 0;
        }
        long ans;
        if(length != 1)
            ans = (max - 1) * get_cnt(max, length - 1, max_appeared);
        else
            ans = (max - 3) * get_cnt(max, length - 1, max_appeared);
        ans += get_cnt(max, length - 1, true);
        return ans;
    }

    static List<Integer> get_nth(long max, long length, boolean max_appeared, long n){
        if(length == 0)
            return new ArrayList<Integer>();
        long not_max = get_cnt(max, length - 1, max_appeared);
        long skip = length == 1? max - 3 : max - 1;
        if(not_max != 0)
            skip = Math.min(skip, n / not_max);
        long take = skip + 1;
        //cout << "length, not_max: " << length << " " << not_max << endl;
        //cout << "skip: " << skip << endl;
        if(length == 1)
            take += 2;
        //cout << "take here: " << take;
        //cout << "so i decide to take " << take << endl;
        //assert(n >= skip * not_max);
        //assert(n - skip * not_max >= 0);
        List<Integer> ans = get_nth(max, length - 1, take == max? true : max_appeared, n - skip * not_max);
        ans.add(0, (int) take);
        return ans;
    }

    static List<Integer> solution(long n){  /// n - на 1 больше обычного, так как индексация с 0
        long max_l = 2, max_r = (long) 1e3 + 3;  /// l <=, r >
        while(max_r - max_l > 1){
            long mid = (max_l + max_r) / 2;
            if(get_cnt_with_max_no_more(mid) > n)
                max_r = mid;
            else
                max_l = mid;
        }
        long max = max_r;
        n -= get_cnt_with_max_no_more(max - 1);
        //cout << "n, max: " << n << " " << max << endl;
        return get_nth(max, 4, false, n);
    }

    public static void main(String[] args){
        long l, r;
        Scanner sc = new Scanner(System.in);
        l = sc.nextLong();
        r = sc.nextLong();
        l--; r--;
        //cout << "get_cnt_with_max_no_more(3): " << get_cnt_with_max_no_more(3) << endl;
        //auto sol = get_nth(4, 2, false, 3);
        //    for(long x : sol)
        //        cout << x << " ";
        //    cout << endl;
        //return 0;
        for(long i = l; i <= r; i++) {
            List<Integer> sol = solution(i);
            int a = sol.get(0), b = sol.get(1), c = sol.get(2);
            int n = sol.get(3);
            //cout << sol[0] << "^" << sol[3] << "+" << sol[1] << "^" << sol[3] << "=" << sol[2] << "^" << sol[3] << "\n";
            BigInteger a_big = BigInteger.valueOf(a);
            BigInteger b_big = BigInteger.valueOf(b);
            BigInteger c_big = BigInteger.valueOf(c);
            BigInteger lch = a_big.pow(n).add(b_big.pow(n));
            BigInteger rch = c_big.pow(n);

            //BigInteger a_big = BigInteger.valueOf(a);
            System.out.print(a + "^" + n + "+" + b + "^" + n +
                    (lch.compareTo(rch) > 0? ">" : "<")
                    + c + "^" + n + "\n");
        }
    }

}
