#include <bits/stdc++.h>
using namespace std;

vector<string> split(string &s){
    vector<string> ans;
    string cur;
    for(char c : s){
        if(c == '.' || c == '/'){
            ans.push_back(cur);
            cur = "";
        }
        else
            cur += c;
    }
    ans.push_back(cur);
    return ans;
}

void add(string &s, int num){
    while(s.size() < num)
        s.insert(s.begin(), '0');
    while(s.size() > num)
        s.erase(s.begin());
}

int main(){
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int n;
    cin >> n;
    for(int i = 0; i < n; i++){
        string s;
        cin >> s;
        auto spl = split(s);
        if(find(s.begin(), s.end(), '/') != s.end())
            swap(spl[0], spl[1]);
        add(spl[0], 2);
        add(spl[1], 2);
        add(spl[2], 4);
        cout << spl[0] << "." << spl[1] << "." << spl[2] << " " << spl[1] << "/" << spl[0] << "/" << spl[2] << "\n";
    }
    return 0;
}
