#define _CRT_SECURE_NO_WARNINGS
#include <stdio.h>
#include <iostream>
#include <algorithm>
#include <math.h>

using namespace std;

struct inf {
	long long int x, y;
	inf() {}
	inf(long long int x, long long int y) {
		this->x = x;
		this->y = y;
	}
	long long int operator%(const inf& b) {
		return x * b.y - y * b.x;
	}
	inf operator-(const inf& b) {
		return inf(b.x - x, b.y - y);
	}
	inf operator+(const inf& b) {
		return inf(x + b.x, y + b.y);
	}
	inf operator*(const int& b) {
		return inf(x * b, y * b);
	}
};

bool inside(inf a, inf b, inf c, inf d) {
	return abs((a - b) % (a - c)) == abs((a - d) % (a - c)) + abs((a - d) % (a - b)) + abs((b - d) % (b - c));
}

int n;

int main() {
	scanf("%d", &n);
	long long int x1, y1, x2, y2, x3, y3, x4, y4, x, y;
	for (int i = 0; i < n; i++) {
		scanf("%lld %lld %lld %lld %lld %lld %lld %lld %lld %lld", &x1, &y1, &x2, &y2, &x3, &y3, &x4, &y4, &x, &y);
		inf a1(x1, y1), a2(x2, y2), b1(x3, y3), b2(x4, y4);
		inf v(x, y);
		inf a3 = a1 + (v * 1e9);
		inf a4 = a2 + (v * 1e9);
		inf b3 = b1 + (v * -1e9);
		inf b4 = b2 + (v * -1e9);
		if (inside(a1, a2, a3, b1) || inside(a1, a2, a3, b2) || inside(a1, a2, a4, b1) || inside(a1, a2, a4, b2) ||
			inside(b1, b2, b3, a1) || inside(b1, b2, b3, a2) || inside(b1, b2, b4, a1) || inside(b1, b2, b4, a2)) printf("Yes\n");
		else printf("No\n");
	}
	return 0;
}