class Vector:
    x: int = 0
    y: int = 0

    def __mul__(self, other: int):
        a = Vector()
        a.x = self.x * other
        a.y = self.y * other
        return a

    def __neg__(self):
        a = Vector()
        a.x = -self.x
        a.y = -self.y
        return a

    def __mod__(self, other):
        return self.x * other.y - self.y * other.x

    def __add__(self, other):
        a = Vector()
        a.x = self.x + other.x
        a.y = self.y + other.y
        return a

    def __sub__(self, other):
        a = Vector()
        a.x = self.x - other.x
        a.y = self.y - other.y
        return a

    def __pow__(self, other):
        return self.x * other.x + self.y * other.y


def inside(a: Vector, b: Vector, c: Vector, d: Vector):
    area = abs((a - b) % (c - b))
    area1 = abs((a - d) %(b - d)) + abs((b - d) % (c - d)) + abs((a - d) % (c - d))
    return area == area1


def check(a1, a2, b1, b2, v):
    return ((b1 - a1) % v) *(v % (b2 - a1)) > 0 or ((b1 - a2) % v) *(v % (b2 - a2)) > 0 or \
           (v ** (b1 - a1) > 0 and v % (b1 - a1) == 0) or (v ** (b2 - a1) > 0 and v % (b2 - a1) == 0) or \
           (v ** (b1 - a2) > 0 and v % (b1 - a2) == 0) or (v ** (b2 - a2) > 0 and v % (b2 - a2) == 0)


n = int(input())
for i in range(n):
    x1, y1, x2, y2, x3, y3, x4, y4, x, y = map(int, input().split())
    a1 = Vector()
    a1.x = x1
    a1.y = y1
    a2 = Vector()
    a2.x = x2
    a2.y = y2
    b1 = Vector()
    b1.x = x3
    b1.y = y3
    b2 = Vector()
    b2.x = x4
    b2.y = y4
    v = Vector()
    v.x = x
    v.y = y
    if check(a1, a2, b1, b2, v) or check(b1, b2, a1, a2, -v):
        print("Yes")
    else:
        print("No")
