#include <iostream>
#include <algorithm>
#include <vector>
#include <cstring>
#include <string>
#include <queue>
#define x first
#define y second

using namespace std;

typedef pair<int, int> Point;
typedef long long ll;

string s;

void command(int h, int w)
{
	int m = (h + 1) / 2;
	for (int i = 1; i < m; ++i)
		s.push_back('D');
	for (int i = 1; i < w; ++i)
		s.push_back('R');
	for (int i = m; i < h; ++i)
		s.push_back('D');
}

int main()
{
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int m, n;
	cin >> m >> n;
	queue<Point> a;
	queue<Point> b;
	a.push({ 0, 0 });
	a.push({ m - 1, n - 1 });
	while (a.size() < m + n - 1)
	{
		s = "";
		Point fir;
		Point sec = a.front();
		a.pop();
		while (a.size())
		{
			swap(fir, sec);
			sec = a.front();
			a.pop();
			command(sec.x - fir.x + 1, sec.y - fir.y + 1);
		}
		cout << "? " << s << endl;
		int c;
		cin >> c;
		for (int i = 0; i < c; ++i)
		{
			int u, z;
			cin >> u >> z;
			b.push({ u - 1, z - 1 });
		}
		swap(a, b);
	}
	cout << "! " << s << endl;
}
