#include <bits/stdc++.h>

#define int long long
//#define endl '\n'
#define mp make_pair
#define pb emplace_back
#define all(C) (C).begin(), (C).end()
#define rall(C) (C).rbegin(), (C).rend()
#define dbg(x) cerr << #x << " : " << x << endl

using namespace std;

using ll = long long;
using ld = double;
using pii = pair <int, int>;
using pll = pair <ll, ll>;
using pld = pair <ld, ld>;

template <class T>
istream& operator>> (istream &in, vector <T> &a) {for (auto &i : a) in >> i; return in;}
template <class T>
ostream& operator<< (ostream &out, vector <T> a) {for (auto i : a) out << i << " "; return out;}
template <class T, class U>
istream& operator>> (istream &in, pair <T, U> &a) {in >> a.first >> a.second; return in;}
template <class T, class U>
ostream& operator<< (ostream &out, pair <T, U> a) {out << a.first << " " << a.second; return out;}

vector< vector<int> > dp;
string kthpsp(int n, int k, int bal) {
    if(n == 0) {
        return "";
    }
    if(bal == n || dp[bal + 1][n - 1] <= k) {
        return "}" + kthpsp(n - 1, k - (bal == n ? 0 : dp[bal + 1][n - 1]), bal - 1);
    } else {
        return "{" + kthpsp(n - 1, k, bal + 1);
    }
}
string kthpsp(int n, int k) {
    return kthpsp(n, k, 0);
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    string s;
    cin >> s;



    int k;
    cin >> k;

    int now = 0;
    vector<int> pos;
    vector<bool> need(s.size());
    for (int i = 1; i < s.size(); i++) {
        if (s[i] == '-' && s[i - 1] == '-') {
            now++;
            pos.push_back(i - 1);
            need[i - 1] = true;
        }
    }

    int n = ((now + 1) / 2) * 2;
    dp.resize(n / 2 + 1, vector<int>(n + 1));
    dp[0][0] = 1;
    for(int l = 1; l <= n; l++) {
        for(int pref = 0; pref <= n / 2; pref++) {
            if(pref == 0) {
                dp[0][l] = dp[1][l - 1];
            } else {
                dp[pref][l] = (pref == n / 2 ? 0 : dp[pref + 1][l - 1]) + dp[pref - 1][l - 1];
            }
        }
    }

    int count1 = 0;

    if (now % 2 == 0) {
        if(k > dp[0][n]) {
            cout << "Overflow";
            return 0;
        }
        string k1 = kthpsp(n, k - 1);
        int ind = 0;
        for (int i = 0; i < s.size(); i++) {
            cout << s[i];
            if (need[i]) {
                cout << k1[ind];
                ind++;
            }
        }
    } else {
        int put = -1;
        int count1 = 0;
        cout << dp[0][n] << " ";
        cout << count1 << " ";
        for (int i = s.size() - 1; i >= 0; i--) {
            count1 += dp[0][n];

            if (count1 >= k) {
                put = i;
                break;
            }
        }

        cout << put << endl;
        if (put == -1) {
            count1 += dp[0][n];
            if (count1 >= k) {
                put = -10;
            } else {
                cout << "Overflow";
                return 0;
            }
        }

        k -= (count1 - dp[0][n]);

        string k1 = kthpsp(n, k - 1);
        int ind = 0;
        if (put == -10) {
            cout << k1[ind];
            ind++;
        }
        for (int i = 0; i < s.size(); i++) {
            cout << s[i];
            if (need[i]) {
                cout << k1[ind];
                ind++;
            }
            if (put == i) {
                cout << k1[ind];
                ind++;
            }
        }
    }
    return 0;


}

