#include <bits/stdc++.h>

#define ll long long
#define ld long double
#define pii pair < int , int >
#define pb push_back
#define F first
#define S second
#define endl '\n'
using namespace std;

const int maxn = 1e5 + 5;
const ll inf = 1e18;

ll l, r, n;
vector<string> ans;

void solve(ll a, ll b, ll c, ll d, ll n){
    ll L = max(a, c);
    ll R = min(b, d);
    if (L > R) return;
//    cerr << l << ' ' << r << endl;
    for (ll x = L; x <= R; x++){
        ll l = x - a;
        int a = (l)/(n*n) + 1, b = ((l)/n)%n + 1, c = l%n + 1;
        string now;
        now += to_string(a);
        now += "^";
        now += to_string(n);
        now += "+";
        now += to_string(b);
        now += "^";
        now += to_string(n);
        if (log(a)*n + log(b)*n < log(c)*n) now += "<";
        else now += ">";
        now += to_string(c);
        now += "^";
        now += to_string(n);
        ans.pb(now);
//        cerr << l << endl;
    }
}

int main()
{
    ios_base::sync_with_stdio(0);
#ifdef LOCAL
    freopen("input.txt","r",stdin);
    freopen("output.txt","w",stdout);
#endif
    cin >> l >> r;
    ll add = 0;
    for (n = 3; 1; n++){
        ll cur = n*n*n;
        if (add > (ld)(1e13)) break;
        solve(add + 1, add + cur, l, r, n);
//        cerr << n << endl;
        add += cur;
    }
    for (auto it : ans) cout << it << endl;
    return 0;
}
