#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using namespace __gnu_pbds;

#define x first
#define y second
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
#define all(x) begin(x), end(x)
#define SZ(x) ((int) x.size())

bool answ[1009][1009];
string go = "";
bool ok = 0;

int n, m;
void dfs(int x, int y, int dx, int dy) {
    if (x == dx && y == dy) {
        return;
    }

    if (x + 1 < n && answ[x + 1][y]) {
        go += 'D';
        dfs(x + 1, y, dx, dy);
    }

    else {
        go += 'R';
        dfs(x, y + 1, dx, dy);
    }
}

signed main() {
    #ifdef LC
    freopen("input.txt", "r", stdin);
#endif // LC
    ios::sync_with_stdio(0);
    cin.tie(0);

    cin >> n >> m;

    vector<pair<pii, pii>> ques;
    ques.push_back({{0, 0}, {n - 1, m - 1}});

    for (int it = 0; it < 10; it++) {
        vector<pair<pii, pii>> new_q;
        string way = "";

        int prevx = 0, prevy = 0;

        for (int pos = 0; pos < ques.size(); pos++) {
            auto u = ques[pos];
            int i1 = u.x.x, j1 = u.x.y, i2 = u.y.x, j2 = u.y.y;
            //cout << "\t" << i1+1 << ' ' << j1+1 << ' ' << i2+1 << ' ' << j2+1 << endl;

                go = "";
                dfs(prevx, prevy, i1, j1);
                way += go;


            if (i2 - i1 == 0 && j2 - j1 == 0) {
                continue;
            }

            int mid = (i1 + i2) / 2;
            for (int k = i1; k < mid; k ++) {
                way += 'D';
            }

            for (int k = j1; k < j2; k++) {
                way += 'R';
            }

            for (int k = mid; k < i2; k ++) {
                way += 'D';
            }

            prevx = i2;
            prevy = j2;
        }

        if (way.size() == 0) break;

        cout <<"? " <<  way << endl;
        int sz;
        cin >> sz;
        vector<pii> bounds(n, {1000000, -1000000});

        for (int i = 0; i < sz; i ++) {
            int x, y;
            cin >> x >> y;
            x--;
            y--;

            bounds[x].x = min(bounds[x].x, y);
            bounds[x].y = max(bounds[x].y, y);
        }

        for (auto u : ques) {
            int i1 = u.x.x, j1 = u.x.y, i2 = u.y.x, j2 = u.y.y;
            if (i2 - i1 == 0 && j2 - j1 == 0) {
                continue;
            }

            int mid = (i1 + i2) / 2;
            for (int k = bounds[mid].x; k <= bounds[mid].y; k++) {
                answ[mid][k] = 1;
            }

            if (i2 - i1 == 1) {
                for (int k = bounds[mid].y; k <= j2; k++) {
                    answ[i2][k] = 1;
                }

                continue;
            }

            new_q.push_back({{i1, j1}, {mid, bounds[mid].x}});
            new_q.push_back({{mid, bounds[mid].y}, {i2, j2}});
        }

        ques = new_q;
    }
    go = "";
    dfs(0, 0, n - 1, m - 1);
    cout << "! " << go << endl;

    return 0;
}
