#define _CRT_SECURE_NO_WARNINGS
#include<iostream>
#include<vector>
#include<cstdlib>
#include<cmath>
#include<algorithm>
#include<cstring>

using namespace std;
#define int long long

struct pt {
	double x, y;
	double cross(const pt& oth) const {
		return x * oth.y - y * oth.x;
	}
	double dot(const pt& oth) const {
		return x * oth.x + y * oth.y;
	}
};

bool check(pt a, pt l, pt r, pt v) {
	pt x = { l.x - a.x, l.y - a.y };
	pt y = { r.x - a.x, r.y - a.y };
	if (v.dot(x) < 0 || v.dot(y) < 0) return 0;
	if (v.cross(x) * v.cross(y) <= 0) return 1;
	return 0;
}

signed main() {
#ifdef _DEBUG
	freopen("in.txt", "r", stdin);
#endif
	int t;
	cin >> t;
	for (int i = 0; i < t; i++) {
		pt al, ar, bl, br, v;
		cin >> al.x >> al.y >> ar.x >> ar.y >> bl.x >> bl.y >> br.x >> br.y >> v.x >> v.y;
		if (check(al, bl, br, v) || check(ar, bl, br, v)) cout << "Yes";
		else {
			pt vv = { -v.x, -v.y };
			if (check(bl, al, ar, vv) || check(br, al, ar, vv)) cout << "Yes";
			else cout << "No";
		}
		cout << endl;
	}
}