// task.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <string>
#include <cmath>

#define int long double
#define VI vector<int>
#define VB vector<bool>
#define pb push_back
#define x first
#define y second
#define PAR pair<int, int>
#define BIG 1e8
#define EPS 1e-9
using namespace std;

struct SEG{
	PAR a, b;
	SEG(PAR x, PAR y){
		a=x;
		b=y;
	}
};
struct LIN{
	int a, k;
	LIN(int aa, int kk){
		a=aa;
		k=kk;
	}
	LIN(SEG s){
		k=(s.a.y-s.b.y)/(s.a.x-s.b.x);
		a=s.a.y-s.a.x*k;
	}
};
pair<signed, PAR> peer(LIN a, LIN b){
	if(abs(a.k-b.k)<EPS){
		if(abs(a.a-b.a)<EPS){
			return pair<signed, PAR>(-1, PAR(BIG, BIG));
		}
		return pair<signed, PAR>(1, PAR(BIG, BIG));
	}
	int aa=(b.a-a.a)/(a.k-b.k);
	return pair<signed, PAR>(0, PAR(aa, a.a+a.k*aa));
}
bool in(int x, int l, int r){
	if(l>r){
		swap(l, r);
	}
	if((x<=r)&&(x>=l)){
		return true;
	}
	return false;
}
PAR minuss(PAR a, PAR b){
	return PAR(a.x-b.x, a.y-b.y);
}
bool per(LIN l, SEG s, PAR startp, PAR vec){
	if(s.a.x==s.b.x){
		int y1=s.a.y;
		int y2=s.b.y;
		int x=s.a.x;
		int y=l.a+l.k*x;
		return in(y, y1, y2);
	}
	LIN r(s);
	pair<signed, PAR> pa=peer(l, r);
	PAR p=pa.second;
	if(pa.first==-1){
		return true;
	}
	if(pa.first==1){
		return false;
	}
	if(in(p.x, s.a.x, s.b.x)&&in(p.y, s.a.y, s.b.y)){
		PAR resv=minuss(p, startp);
		if(resv.x*vec.x>=0){
			return true;
		}
	}
	return false;
}
PAR sum(PAR a, PAR b){
	return PAR(a.x+b.x, a.y+b.y);
}
signed main()
{
	signed n;
	cin>>n;
	VB ans;
	for(signed e=0;e<n;++e){
		int ax1, ay1, ax2, ay2, bx1, by1, bx2, by2, vx, vy;
		cin>>ax1>>ay1>>ax2>>ay2>>bx1>>by1>>bx2>>by2>>vx>>vy;
		if(ax1>ax2){
			swap(ax1, ax2);
			swap(ay1, ay2);
		}
		if(bx1>bx2){
			swap(bx1, bx2);
			swap(by1, by2);
		}
		if(vx==0){
			if(bx1>ax2){
				ans.pb(false);
				continue;
			}
			if(bx2<ax1){
				ans.pb(false);
				continue;
			}
			ans.pb(true);
			continue;
		}
		SEG a(PAR(ax1, ay1), PAR(ax2, ay2));
		SEG b(PAR(bx1, by1), PAR(bx2, by2));
		PAR v(vx, vy);
		if(per(LIN(SEG(a.a, sum(a.a,v))), b, a.a, v)){
			ans.pb(true);
			continue;
		}
		if(per(LIN(SEG(a.b, sum(a.b,v))), b, a.b, v)){
			ans.pb(true);
			continue;
		}
		ans.pb(false);
		continue;
	}
	for(int i=0;i<ans.size();++i){
		if(ans[i]){
			cout<<"YES"<<endl;
		}else{
			cout<<"NO"<<endl;
		}
	}
	return 0;
}

// Run program: Ctrl + F5 or Debug > Start Without Debugging menu
// Debug program: F5 or Debug > Start Debugging menu

// Tips for Getting Started: 
//   1. Use the Solution Explorer window to add/manage files
//   2. Use the Team Explorer window to connect to source control
//   3. Use the Output window to see build output and other messages
//   4. Use the Error List window to view errors
//   5. Go to Project > Add New Item to create new code files, or Project > Add Existing Item to add existing code files to the project
//   6. In the future, to open this project again, go to File > Open > Project and select the .sln file
