// task.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <string>
#include <cmath>

//#define int long long
#define VI vector<int>
#define VC vector<char>
#define VB vector<bool>
#define pb push_back
#define x first
#define y second
#define PAR pair<int, int>
#define BIG 10000000000LL
using namespace std;

#define VVC vector<VC>

int Y, X;
bool seeup(VVC& v, int x, int y){
	int i=0;
	while(y!=0){
		--y;
		for(int xx=max(x-i, 0);xx<=min(x+i, X-1);++xx){
			if(v[xx][y]!='.'){
				return true;
			}
		}
		++i;
	}
	return false;
}
bool seeleft(VVC& v, int x, int y){
	int i=0;
	while(x!=0){
		--x;
		for(int yy=max(y-i, 0);yy<=min(y+i, Y-1);++yy){
			if(v[x][yy]!='.'){
				return true;
			}
		}
		++i;
	}
	return false;
}
bool seedown(VVC& v, int x, int y){
	int i=0;
	while(y!=Y-1){
		++y;
		for(int xx=max(x-i, 0);xx<=min(x+i, X-1);++xx){
			if(v[xx][y]!='.'){
				return true;
			}
		}
		++i;
	}
	return false;
}
bool seeright(VVC& v, int x, int y){
	int i=0;
	while(x!=X-1){
		++x;
		for(int yy=max(y-i, 0);yy<=min(y+i, Y-1);++yy){
			if(v[x][yy]!='.'){
				return true;
			}
		}
		++i;
	}
	return false;
}
bool see(VVC& v, int x, int y){
	if(v[x][y]=='U'){
		return seeup(v, x, y);
	}
	if(v[x][y]=='D'){
		return seedown(v, x, y);
	}
	if(v[x][y]=='L'){
		return seeleft(v, x, y);
	}
	if(v[x][y]=='R'){
		return seeright(v, x, y);
	}
}
char rot(char c){
	switch(c){
		case 'U':
			return 'L';
		case 'L':
			return 'D';
		case 'D':
			return 'R';
		case 'R':
			return 'U';
	}
}
char arot(char c){
	return rot(rot(rot(c)));
}
char povorot(char c){
	return rot(rot(c));
}
void solve(VVC& v, int x, int y){
	if(!see(v, x, y)){
		return;
	}
	v[x][y]=rot(v[x][y]);
	if(!see(v, x, y)){
		return;
	}
	v[x][y]=povorot(v[x][y]);
	if(!see(v, x, y)){
		return;
	}
	v[x][y]=arot(v[x][y]);
	if(!see(v, x, y)){
		return;
	}
}
signed main()
{
	cin>>Y>>X;
	vector<VC> v(X, VC(Y));
	for(int y=0;y<Y;++y){
		string s;
		cin>>s;
		for(int x=0;x<X;++x){
			v[x][y]=s[x];
		}
	}
	for(int x=0;x<X;++x){
		for(int y=0;y<Y;++y){
			if(v[x][y]=='.'){
				continue;
			}
			solve(v, x, y);
		}
	}
	for(int y=0;y<Y;++y){
		for(int x=0;x<X;++x){
			cout<<v[x][y];
		}
		cout<<endl;
	}
	return 0;
}

// Run program: Ctrl + F5 or Debug > Start Without Debugging menu
// Debug program: F5 or Debug > Start Debugging menu

// Tips for Getting Started: 
//   1. Use the Solution Explorer window to add/manage files
//   2. Use the Team Explorer window to connect to source control
//   3. Use the Output window to see build output and other messages
//   4. Use the Error List window to view errors
//   5. Go to Project > Add New Item to create new code files, or Project > Add Existing Item to add existing code files to the project
//   6. In the future, to open this project again, go to File > Open > Project and select the .sln file
