#pragma GCC optimize("O3,unroll-loops,inline,fast-math")
#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;
#define all(x) (x).begin(),(x).end()
int n;
string get_pos(int i, int j) {
    string ans;
    ans = "";
    ans += 'a' + j;
    ans += '1' + i;
    return ans;
}

void out(string a, string b, string c) {
    cout << a << " > " << b << " ? " << c << "\n";
}

void sort_square_l(int i, int j) {
    string a1, a2, b1, b2;
    a1 = get_pos(i, j);
    a2 = get_pos(i, j + 1);
    b1 = get_pos(i + 1, j);
    b2 = get_pos(i + 1, j + 1);
    out(a1, b1, a1);

    out(a2, b1, a1);
    out(a1, b1, a1);

    out(b2, b1, a1);
    out(a2, b1, a1);
    out(a1, b1, a1);
}


void sort_square_r(int i, int j) {
    string a1, a2, b1, b2;
    a1 = get_pos(i, j);
    a2 = get_pos(i, j + 1);
    b1 = get_pos(i + 1, j);
    b2 = get_pos(i + 1, j + 1);
    out(b1, b2, a1);

    out(a1, b2, a1);
    out(b1, b2, a1);

    out(a2, b2, a1);
    out(a1, b2, a1);
    out(b1, b2, a1);
}

void sort_square_u(int i, int j) {
    string a1, a2, b1, b2;
    a1 = get_pos(i, j);
    a2 = get_pos(i, j + 1);
    b1 = get_pos(i + 1, j);
    b2 = get_pos(i + 1, j + 1);
    out(a2, a1, a1);

    out(b2, a1, a1);
    out(a2, a1, a1);

    out(b1, a1, a1);
    out(b2, a1, a1);
    out(a2, a1, a1);
}

void sort_row(int i) {
    for (int j = n - 2; j >= 0; j--)
        sort_square_l(i, j);
}

void get_max(int i) {
    for (int j = 0; j <= i - 2; j++)
        sort_row(j);
}

void sort_pos(int i, int j) {
    for (int k = 0; k <= j - 1; k++)
        sort_square_r(i - 1, k);
}

void make_max(int i) {
    sort_square_u(i - 1, 0);
}

void sort_position(int i, int j) {
    sort_pos(i, j);
    get_max(i);
    make_max(i);
    sort_square_l(i - 1, 0);
    sort_square_l(i - 2, 0);
    string a1, b1, b2;
    a1 = get_pos(i - 1, 0);
    b1 = get_pos(i, 0);
    b2 = get_pos(i, 1);
    out(b1, b2, a1);
    sort_pos(i, j);
}

int main() {
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    cout.precision(20), cout.setf(ios::fixed);
    cin >> n;
    if (n == 2) {
        cout << "a1 > a2 ? a1" << endl;
        return 0;
    }

    for (int i = n - 1; i >= 2; i--) {
        for (int j = n - 1; j >= 0; j--) {
            sort_position(i, j);
        }
    }
    return 0;
}