#include <stdio.h>
#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

vector  <vector <bool> > used;



int main() {
    int n, m;
    cin >> n >> m;

    used.assign(n, vector <bool> (m, 0));

    used[0][0] = 1;
    used[n - 1][m - 1] = 1;

    vector <pair <int, int> > board_x;
    board_x.push_back({-1, m});

    vector <int> board_y(m, n - 1);

    for(int _q = 0; _q < 10; ++_q) {

        vector <pair <int, int> > __board_x;

        cout << "? ";

        int _i = 0;
        int _j = 0;

        for(int cur = 0; cur < (int)board_x.size(); ++cur) {

            int mid = (board_x[cur].first + board_x[cur].second) / 2;

            for(int i = _i; i < mid; ++i) {
                cout << "R";
                _i = i + 1;
            }

            for(int j = _j; j < board_y[mid]; ++j) {
                cout << "D";
                _j = j + 1;
            }

            __board_x.push_back({board_x[cur].first, mid});
            __board_x.push_back({mid, board_x[cur].second});
        }

        for(int i = _i; i < m - 1; ++i) {
            cout << "R";
        }

        for(int j = _j; j < n - 1; ++j) {
            cout << "D";
        }

        cout << endl;

        int num;
        cin >> num;

        __board_x.assign(0, {0, 0});

        int cur = 0;

        while(num--) {

            int x, y;
            cin >> x >> y;

            while(cur < (int)board_x.size() && board_x[cur].second < x - 1) {
                ++cur;
            }

            used[x - 1][y - 1] = 1;
            board_y[y - 1] = x - 1;

            __board_x.push_back({board_x[cur].first, x - 1});
            __board_x.push_back({x - 1, board_x[cur].second});
        }

        board_x = __board_x;

        sort(board_x.begin(), board_x.end());
    }

    int i = 0;
    int j = 0;

    cout << "! ";

    while(i < n - 1 || j < m - 1) {

        if(i + 1 < n && used[i + 1][j] == 1) {
            cout << "D";
            ++i;
        }
        else {
            cout << "R";
            ++j;
        }

    }

    cout << endl;

    return 0;
}
