#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <string>
#include <string.h>
#include <math.h>
#include <vector>
#include <set>
#include <map>
#include <iomanip>

using namespace std;

typedef long long ll;
typedef long double db;
typedef pair <int, int> pii;

const int N = (int)60;

string s, t;
int cnt;
ll dp[N + 1][N + 1][2], k;

void solve() {
	dp[s.size()][0][0] = 1;
	for (int i = (int)s.size() - 1; i >= 0; ++i) {
		for (int h = 0; h <= s.size(); ++h) {
			for (int ins = 0; ins < 2; ++ins) {
				if (!ins) {
					if (s[i] != '?') {
						dp[i][h][ins] = dp[i + 1][h][ins];
					} else {
						dp[i][h][ins] = dp[i + 1][h + 1][ins];
						if (h > 0) {
							dp[i][h][ins] += dp[i + 1][h - 1][ins];
						}
					}
				} else {
					if (s[i] != '?') {
						dp[i][h][ins] = dp[i + 1][h][ins];
						dp[i][h][ins] += dp[i + 1][h + 1][0];
						if (h > 0) {
							dp[i][h][ins] += dp[i + 1][h - 1][0];
						}
					} else{
						dp[i][h][ins] = dp[i + 1][h + 1][ins];
						if (h > 0) {
							dp[i][h][ins] += dp[i + 1][h - 1][ins];
						}
					}
				}
			}
		}
	}
}

signed main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(0);
	cin >> s;
	for (int i = 0; i < (int)s.size() - 1; ++i) {
		t.push_back(s[i]);
		if (s[i] == '-' && s[i + 1] == '-') {
			t.push_back('?');
			++cnt;
		}
	}
	t.push_back(s.back());
	s = t;
	cin >> k;
	solve();
	--k;
	int left_ = (cnt & 1);
	if (left_) {
		if (dp[0][0][0] + dp[0][0][1] <= k) {
			cout << "Overflow";
			return 0;
		}
	} else {
		if (dp[0][0][0] <= k) {
			cout << "Overflow";
			return 0;
		}
	}
	int h = 0;
	for (int i = 0; i < t.size(); ++i) {
		if (t[i] == '?') {
			ll cnt1 = dp[i + 1][h + 1][left_];
			if (cnt <= k) {
				cout << '{';
			} else {
				k -= cnt1;
				cout << '}';
			}
		} else {
			cout << t[i];
			ll cnt1 = dp[i + 1][h + 1][0];
			if (cnt1 <= k) {
				k -= cnt1;
				if (h > 0) {
					ll cnt2 = dp[i + 1][h - 1][0];
					if (cnt2 <= k) {
						k -= cnt2;
						cout << '}';
					} else {
						cout << '{';
					}
				} else {
					cout << '{';
				}
			}
		}
	}
	return 0;
}