#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <string>
#include <iostream>
#include <map>
#include <set>
#include <cmath>
#include <fstream>
#include <math.h>
#include <algorithm>

#define all(a) a.begin(), a.end()
#define mp make_pair
#define rt return
#define ll long long
#define ld long double

#define rep(n, i) for(int i=0;i<n;i++)
#define per(n, i) for(int i=n - 1;i>= 0;--)



using namespace std;

const int MAX_SIZE = 1e5, INF = 2e9;
const long long SuperINF = 1e18;
const ld eps = 1e-8;


void files() {
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
}

struct vec {
	ld x, y;
	vec(ld x_, ld y_) {
		x = x_;
		y = y_;
	}


};


int znak(ld a) {
	if (a > 0)
		return 1;
	if (a < 0)
		return -1;

	return 0;
}


long double operator*(vec a, vec b) {
	return a.x * b.x + a.y * b.y;
}

struct line {
	ld a, b, c;

	line(vec p1, vec p2) {
		a = p2.y - p1.y;
		b = p1.x - p2.x;
		c = p1.x * (p1.y - p2.y) + p1.y * (p2.x - p1.x);

	}
};

bool check2(vec a, vec b, vec in) {
	vec v1(a.x - b.x, a.y - b.y);
	vec v_in1(in.x - b.x, in.y - b.y);

	vec v2(b.x - a.x, b.y - a.y);
	vec v_in2(in.x - a.x, in.y - a.y);

	if (v1 * v_in1 >= 0 && v2 * v_in2 >= 0)
		return true;

	return false;
}


int check(vec p, vec a, vec b, vec v) {
	line l = line(a, b);
	ld d = l.a * v.x + l.b * v.y;
	ld r = -(l.c + l.a * p.x + l.b * p.y);
	
	if (fabs(d) < eps) {

		if (fabs(r) < eps) {
			vec ff(a.x - p.x, a.y - p.y);
			if (ff * v >= 0)
				return true;

			return false;
		}
		else {
			return 0;
		}
	}
	else {
		ld t = r / d;
		vec in = vec(v.x * t + p.x, v.y * t + p.y);

		vec cc1(in.x - p.x, in.y - p.y);

		if (cc1 * v >= 0 && check2(a, b, in))
			return 1;
		else
			return 0;
	}

}


void solved() {
	ld ax1, ay1, ax2, ay2;
	cin >> ax1 >> ay1 >> ax2 >> ay2;
	ld bx1, by1, bx2, by2;
	cin >> bx1 >> by1 >> bx2 >> by2;
	ld vx, vy;
	cin >> vx >> vy;


	vec v = vec(vx, vy);
	vec a1 = vec(ax1, ay1);
	vec a2 = vec(ax2, ay2);
	vec b1 = vec(bx1, by1);
	vec b2 = vec(bx2, by2);

	if (check(a1, b1, b2, v) || check(a2, b1, b2, v) || check(b1, a1, a2, vec(-v.x, -v.y)) || check(b2, a1, a2, vec(-v.x, -v.y))) {
		cout << "Yes\n";
	}
	else {
		cout << "No\n";
	}
}


int main() {
	std::ios_base::sync_with_stdio(false);
	files();
	int n;
	cin >> n;
	rep(n, i) {
		solved();
	}



	return 0;
}