#include<bits/stdc++.h>
using namespace std;

#define x first
#define y second

#define all(a) (a).begin(), (a).end()

#define int long long
#define ld long double

bool ok(ld x, ld y, ld x1, ld y1) {
    return x * x1 + y * y1 > 0.0;
}

void nor(int &a, int &b, int &c) {
    int g = __gcd(a, __gcd(b, c));
    a /= g;
    b /= g;
    c /= g;
    if (a < 0) {
        a *= -1;
        b *= -1;
        c *= -1;
    }
    if (a == 0 && b < 0) {
        b *= -1;
        c *= -1;
    }
}

bool eq(int a, int b, int c, int aa, int bb, int cc) {
    nor(a, b, c);
    nor(aa, bb, cc);
    return a==aa&&b==bb && c == cc;
}

bool ok1(ld ax1, ld ay1, ld ax2, ld ay2, ld bx1, ld by1, ld bx2, ld by2) {
    ld a = ay2 - ay1;
    ld b = ax1 - ax2;
    ld c = -a * ax1 - b * ay1;
    ld aa = by2 - by1;
    ld bb = bx1 - bx2;
    ld cc = -aa * bx1 - bb * by1;
    if (aa * b - a * bb == 0.0 && !eq(a, b, c, aa, bb, cc)) {
        return 0;
    }
    return 1;
}

pair<ld, ld> get(ld ax1, ld ay1, ld ax2, ld ay2, ld bx1, ld by1, ld bx2, ld by2) {
    ld a = ay2 - ay1;
    ld b = ax1 - ax2;
    ld c = -a * ax1 - b * ay1;
    ld aa = by2 - by1;
    ld bb = bx1 - bx2;
    ld cc = -aa * bx1 - bb * by1;
    if (eq(a, b, c, aa, bb, cc)) {
        return {bx1, by1};
    }
    return {(cc * b - bb * c) / (bb * a - b * aa), (cc * a - aa * c) / (aa * b - a * bb)};
}

void solve() {
    ld ax1, ay1, ax2, ay2, bx1, by1, bx2, by2, vx, vy;
    cin >> ax1 >> ay1 >> ax2 >> ay2 >> bx1 >> by1 >> bx2 >> by2 >> vx >> vy;
    bool ans = 0;
    if (ok1(ax1, ay1, ax1 + vx, ay1 + vy, bx1, by1, bx2, by2)) {
        pair<ld, ld> p = get(ax1, ay1, ax1 + vx, ay1 + vy, bx1, by1, bx2, by2);
        if (p.x >= min(bx1, bx2) && p.x <= max(bx1, bx2) && p.y >= min(by1, by2) && p.y <= max(by1, by2)) {
            if (ok(p.x - ax1, p.y - ay1, vx, vy)) {
                ans = 1;
            }
        }
    }
    if (ok1(ax2, ay2, ax2 + vx, ay2 + vy, bx1, by1, bx2, by2)) {
        pair<ld, ld> p = get(ax2, ay2, ax2 + vx, by2 + vy, bx1, by1, bx2, by2);
        if (p.x >= min(bx1, bx2) && p.x <= max(bx1, bx2) && p.y >= min(by1, by2) && p.y <= max(by1, by2)) {
            if (ok(p.x - ax2, p.y - ay2, vx, vy)) {
                ans = 1;
            }
        }
    }
    swap(ax1, bx1);
    swap(ax2, bx2);
    swap(ay1, by1);
    swap(ay2, by2);
    vx *= -1;
    vy *= -1;
    if (ok1(ax1, ay1, ax1 + vx, ay1 + vy, bx1, by1, bx2, by2)) {
        pair<ld, ld> p = get(ax1, ay1, ax1 + vx, ay1 + vy, bx1, by1, bx2, by2);
        if (p.x >= min(bx1, bx2) && p.x <= max(bx1, bx2) && p.y >= min(by1, by2) && p.y <= max(by1, by2)) {
            if (ok(p.x - ax1, p.y - ay1, vx, vy)) {
                ans = 1;
            }
        }
    }
    if (ok1(ax2, ay2, ax2 + vx, ay2 + vy, bx1, by1, bx2, by2)) {
        pair<ld, ld> p = get(ax2, ay2, ax2 + vx, by2 + vy, bx1, by1, bx2, by2);
        if (p.x >= min(bx1, bx2) && p.x <= max(bx1, bx2) && p.y >= min(by1, by2) && p.y <= max(by1, by2)) {
            if (ok(p.x - ax2, p.y - ay2, vx, vy)) {
                ans = 1;
            }
        }
    }
    cout << (ans ? "Yes\n" : "No\n");
}

int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    int t;
    cin >> t;
    while (t--) solve();
    return 0;
}
