#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define F first
#define S second
#define fst first
#define sbd second
#define forn(i0, n0) for(int i0 = 0; i0<n0; i0++)
#define forab(i0, a0, b0) for(int i0 = a0; i0<b0; i0++)
#define all(x) x.begin(), x.end()
#define ld long double;

typedef vector<int> vi;




struct Vector {
    ll x, y;

    Vector() {}

    Vector(ll nx, ll ny) {
        x = nx;
        y = ny;
    }
};

ll operator*(const Vector &v1, const Vector &v2) {
    return v1.x * v2.x + v1.y * v2.y;
}

ll operator%(const Vector &v1, const Vector &v2) {
    return v1.x * v2.y - v2.x * v1.y;
}

Vector operator+(const Vector &v1, const Vector &v2) {
    return Vector(v1.x + v2.x, v2.y + v1.y);
}

Vector operator-(const Vector &v1, const Vector &v2) {
    return Vector(v1.x - v2.x, v1.y - v2.y);
}

bool operator == (const Vector &v1, const Vector &v2){
    return ((v1.x == v2.x) && (v1.y == v2.y));
}

int sgn(ll a){
    if (a > 0)
        return 1;
    if (a == 0)
        return 0;
    return -1;
}

int dir(Vector a, Vector b){
    return sgn(a % b);
}

bool interRaySeg(Vector a, Vector b, Vector c, Vector d) {
    b = b - a;
    c = c - a;
    d = d - a;
    a = Vector(0, 0);

    if (dir(c, d) == 0){
        return dir(c, b) == 0 && ((c *b > 0) || (d * b > 0));
    }
    if (a == b || c == a || d == a){
        return true;
    }
    if (dir(b, c) == 0 && b*c > 0)
        return true;
    if (dir(b, d) == 0 && b*d > 0)
        return true;
    return (dir(c, d) == dir(c, b)) && (dir(c, d) == dir(b, d));
}



int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int t;
    cin >> t;
    for (int test = 0; test < t; test++) {
        ll x, y;
        cin >> x >> y;
        Vector a(x, y);
        cin >> x >> y;
        Vector b(x, y);
        cin >> x >> y;
        Vector c(x, y);
        cin >> x >> y;
        Vector d(x, y);
        cin >> x >> y;
        Vector v(x, y);

        b = b - a;
        c = c - a;
        d = d - a;
        a = Vector(0, 0);
        if (interRaySeg(a, v, c, d)){
            cout << "Yes\n";
            continue;
        }
        if (interRaySeg(b, b + v, c, d)){
            cout << "Yes\n";
            continue;
        }

        if (dir(v, b) == 0) {
            cout << "No\n";
            continue;
        }

        if (interRaySeg(a, c, v, b) && interRaySeg(b, c, a, b + v))
            cout << "Yes\n";
        else
            cout << "No\n";

    }
    return 0;
}