#include <iostream>
#include <algorithm>
#include <string>
#include <vector>
using namespace std;

vector <int> v;
string s;

int findq(int a)
{
	int res = 0;
	while (a) {
		a /= 10;
		res++;
	}
	return res;
}

int main()
{
	ios_base::sync_with_stdio(false);

	long long a, b;
	cin >> a >> b;

	if (a == b) {
		cout << "Stable\n";
		cout << 0 << endl;
		return 0;
	}

	int l = max(1, findq(a));

	if (l != 1) {
		long long mx11 = 1;
		for (int i = 0; i < l; i++)
			mx11 = mx11 * 10 + 1;

		while (mx11 % 9 != a % 9)
			mx11++;

		if (a % 9 == b % 9 && b > a) {
			cout << "Stable\n";
			cout << 1 << endl;
			cout << "+ " << (b - a) / 9;
			return 0;
		}


		s.push_back('+');
		v.push_back((mx11 - a) / 9);

		s.push_back('-');
		v.push_back(l);

		a = mx11 % 10;
	}

	while (a % 9 != b % 9) {
		a += 9;
		a %= 10;

		s.push_back('+');
		v.push_back(1);

		s.push_back('-');
		v.push_back(1);
	}

	if (b != a) {
		s.push_back('+');
		v.push_back((b - a) / 9);
	}

	long long ans = 0;
	for (int i = 0; i < v.size(); i++)
		ans += v[i];

	if (ans > 1000) {
		cout << "Broken\n";
		return 0;
	}

	cout << "Stable\n";
	cout << s.size() << endl;
	for (int i = 0; i < s.size(); i++)
		cout << s[i] << ' ' << v[i] << endl;

	return 0;
}