#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>
#include<ext/pb_ds/tree_policy.hpp>

#define pb push_back
#define mp make_pair
#define fi first
#define se second
#define all(x) (x).begin(), (x).end()

using namespace std;
using namespace __gnu_pbds;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
template<typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

const int MAXN = (int)1e3 + 5;
const bool SEND = 1;

int our[MAXN * 2];
int arr[MAXN * 2];

string s;

int n, m;

void rshuff(int l, int r) {
	for (int i = l + 1; i < r; ++i) {
		int p = rand() % (i - l) + l;
		swap(s[i], s[p]);
	}						
}

vector<pii> query(string s) {
	cout << "? " << s << endl;
	vector<pii> ret;

	if (SEND) {
		int t;
		cin >> t;

		for (int i = 1; i <= t; ++i) {
			int x, y;
			cin >> x >> y;
			ret.pb(mp(x, y));
		}
	}
	else {
	 	int x = 1;
	 	
	 	for (int i = 2; i <= n + m; ++i) {
	 		if (arr[i] == x) {
	 			ret.pb(mp(x, i - x));
	 		}

			if (i - 2 < s.size() && s[i - 2] == 'D') {
				++x;
			}
	 	}
	}

	return ret;
}

void solve() {
	cin >> n >> m;

	if (!SEND) {
		string tt;
		cin >> tt;
		int x = 1;

		for (int i = 2; i <= n + m; ++i) {
			arr[i] = x;
			x += (tt[i - 2] == 'D');		         		
		}
	}

	for (int i = 2; i <= n + m; ++i) {
		our[i] = -1;
	}

	our[2] = 1;
	our[n + m] = n;

	for (int i = 1; i < n; ++i) {
		s += 'D';
	}

	for (int i = 1; i < m; ++i) {
		s += 'R';
	}

	vector<pii> seg;
	seg.pb(mp(2, n + m));

	for (int step = 0; step < 10; ++step) {
		for (pii it : seg) {
			int l = it.fi, r = it.se;

			if (l < r) {
				rshuff(l - 2, r - 2);
            }
		}

		vector<pii> vtmp = query(s);

		for (pii it : vtmp) {
			int x = it.fi, y = it.se;
			our[x + y] = x;
		}

		vector<int> tmp;

		for (int i = 2; i <= n + m; ++i) {
			if (our[i] != -1) {
				tmp.pb(i);
			}
		}

		for (int i : tmp) {
			if (i + 1 <= n + m) {
				if (our[i + 1] == -1) {
					our[i + 1] = our[i] + (s[i - 2] != 'D');
				}
			}

			if (i - 1 >= 2) {
				if (our[i - 1] == -1) {
					our[i - 1] = our[i] - (s[i - 3] != 'D');
				}
			}
		}

		int prev = -1;
		seg.clear();
		s.clear();

		for (int i = 2; i <= n + m; ++i) {
			if (our[i] != -1) {
				if (prev != -1) {
					int dx = our[i] - our[prev];
					int dy = (i - prev) - dx;

					for (int j = 0; j < dx; ++j) {
						s += 'D';
					}

					for (int j = 0; j < dy; ++j) {
						s += 'R';
					}

					seg.pb(mp(prev, i));
				}

				prev = i;
			}				
		}
	}

	cout << "! ";

	for (int i = 2; i <= n + m; ++i) {
		assert(our[i] != -1);
	}

	for (int i = 2; i < n + m; ++i) {
		if (our[i] == our[i + 1]) {
			cout << "R";
		}
		else {
			cout << "D";
		}
	}

	cout << endl;
}

int main() {
    int tt = 1;
    srand(time(0));

    while (tt--) {
        solve();
    }

    return 0;
}