#include <bits/stdc++.h>
#define int long long
using namespace std;
typedef long double ld;

const ld eps = 1e-9;

///Some Code
struct vec {
    ld x, y;
    vec (ld x, ld y): x(x), y(y) {}
    vec() {}
};

vec operator-(vec a, vec b) {
    return {a.x-b.x, a.y-b.y};
}

vec rot(vec a, ld alpha) {
    vec b;
    b.x = a.x*cos(alpha) - a.y*sin(alpha);
    b.y = a.y*cos(alpha) + a.x*sin(alpha);
    return b;
}

void solve() {
    vec a1, a2, b1, b2, v;
    cin >> a1.x >> a1.y >> a2.x >> a2.y;
    cin >> b1.x >> b1.y >> b2.x >> b2.y;
    cin >> v.x >> v.y;

    ld alpha = -atan2(v.y, v.x);
    a1 = rot(a1, alpha); a2 = rot(a2, alpha);
    b1 = rot(b1, alpha); b2 = rot(b2, alpha);

    if(a1.y > a2.y) swap(a1, a2);
    if(b1.y > b2.y) swap(b1, b2);

    bool res = false;
    ld l = max(a1.y, b1.y)-eps;
    ld r = min(a2.y, b2.y)+eps;

    if((l <= r) && (a1.x-eps <= b1.x)) {
        res = true;
    }

    if(res)
        cout << "Yes";
    else
        cout << "No";
    cout << "\n";
}

int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    ///----------///

    int n;
    cin >> n;

    while(n--) {
        solve();
    }


    ///----------///
    return 0;
}

/**
2
0 2 1 1 2 2 3 1 1 1
0 2 1 1 2 2 3 1 -1 -1
*/
