#include <iostream>
#include<vector>
#include <algorithm>
#include <cmath>

#define ll long long
using namespace std;
struct Vector{
    int x,y;
    Vector(int x1n,int y1n,int x2n,int y2n){
        x=x2n-x1n;y=y2n-y1n;
    }
    Vector(int xn,int yn){
        x=xn,y=yn;
    }
};
ll operator*(Vector a,Vector b){
    return a.x*b.x+a.y*b.y;
}

bool inside(Vector v1,Vector v2, Vector v3) {
    long double ansum = fabs(acosl(v1*v2 / sqrtl(v1.x * v1.x + v1.y * v1.y) / sqrtl(v2.x * v2.x + v2.y * v2.y)));
    long double an1 = fabs(acosl(v2*v3 / sqrtl(v2.x * v2.x + v2.y * v2.y) / sqrtl(v3.x * v3.x + v3.y * v3.y)));
    long double an2 = fabs(acosl(v1*v3 / sqrtl(v1.x * v1.x + v1.y * v1.y) / sqrtl(v3.x * v3.x + v3.y * v3.y)));

    return fabs(ansum - (an1 + an2)) < 0.000001;
}
int main() {
    int n;
    std::cin >> n;

    for(int i = 0; i < n; i++) {
        long long ax1, ax2, ay1, ay2, bx1, by1, bx2, by2, vx, vy;
        std::cin >> ax1 >> ay1 >> ax2 >> ay2 >> bx1 >> by1 >> bx2 >> by2 >> vx >> vy;

        Vector v1=Vector(ax1,ay1,bx1,by1);
        Vector v2=Vector(ax1,ay1,bx2,by2);
        Vector v3=Vector(vx,vy);

        bool res = inside(v1, v2, v3);

        v1=Vector(ax2,ay2,bx1,by1);
        v2=Vector(ax2,ay2,bx2,by2);

        res = res || inside(v1, v2, v3);

        if(res)
            std::cout << "Yes" << "\n";
        else
            std::cout  << "No" << "\n";
    }
}