#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using ull = unsigned long long;
using ld = long double;

#define all(v) v.begin(),v.end()
#define F first
#define S second
#define PB push_back
#define MT make_tuple
#define sz(v) (int)v.size()

long long fastPow(ll a, ll x) {
    if (x == 1) return a;
    if (x == 0) return 1;
    return fastPow(a, x / 2) * fastPow(a, x / 2 + x % 2);
}

int main(){
    ios_base::sync_with_stdio(0); cin.tie(0);
    cout<<fixed<<setprecision(20);
    ll l, r;
    cin >> l >> r;
    l -= 1;
    r -= 1;
    ll n_l, a_l, b_l, c_l;
    ll n_r, a_r, b_r, c_r;
    ll ops = 0;
    int bl, br, bm;
    ull n_pow_sum[40001];
    n_pow_sum[3] = 0;
    for (int i = 4; i < 40001; i++) n_pow_sum[i] = fastPow(i - 1, 3);
    bl = 3, br = 40000; // ================ n l
    while (br - bl > 1) {
        bm = (bl + br) / 2;
        if (n_pow_sum[bm] > l) br = bm;
        else bl = bm;
    } n_l = bl;
    ops = n_pow_sum[n_l] - n_pow_sum[3];

    bl = 0, br = n_l; // ================ a l
    while (br - bl > 1) {
        bm = (bl + br) / 2;
        if (ops + bm * n_l * n_l > l) br = bm;
        else bl = bm;
    }
    a_l = bl;
    ops += a_l * n_l * n_l;

    bl = 0, br = n_l; // ================ b l
    while (br - bl > 1) {
        bm = (bl + br) / 2;
        if (ops + bm * n_l > l) br = bm;
        else bl = bm;
    }
    b_l = bl;
    ops += b_l * n_l;
    c_l = l - ops;
    a_l += 1;
    b_l += 1;
    c_l += 1;


    bl = 3, br = 40000; // ================ n r
    while (br - bl > 1) {
        bm = (bl + br) / 2;
        if (n_pow_sum[bm] > r) br = bm;
        else bl = bm;
    } n_r = bl;
    ops = n_pow_sum[n_r] - n_pow_sum[3];

    bl = 0, br = n_r; // ================ a r
    while (br - bl > 1) {
        bm = (bl + br) / 2;
        if (ops + bm * n_r * n_r > r) br = bm;
        else bl = bm;
    }
    a_r = bl;
    ops += a_r * n_r * n_r;

    bl = 0, br = n_r; // ====l============ b r
    while (br - bl > 1) {
        bm = (bl + br) / 2;
        if (ops + bm * n_r > r) br = bm;
        else bl = bm;
    }
    b_r = bl;
    ops += b_r * n_r;
    c_r = r - ops;
    a_r += 1;
    b_r += 1;
    c_r += 1;
    //cout << "DEBUG " << n_l << ' ' << a_l << ' ' << b_l << ' ' << c_l << endl;
    //cout << "DEBUG " << n_r << ' ' << a_r << ' ' << b_r << ' ' << c_r << endl;
    ll n = n_l;
    ll a = a_l;
    ll b = b_l;
    ll c = c_l;

    while (a != a_r || b != b_r || c != c_r || n != n_r){
        cout << a << '^' << n << '+' << b << '^' << n;
        cout << (fastPow(a, n) + fastPow(b, n) < fastPow(c, n) ? '<' : '>');
        cout << c << '^' << n << '\n';
        c += 1;
        if (c > n) {c = 1; b += 1;}
        if (b > n) {b = 1; a += 1;}
        if (a > n) {a = 1; n += 1;}
    }

    cout << a << '^' << n << '+' << b << '^' << n;
    cout << (fastPow(a, n) + fastPow(b, n) < fastPow(c, n) ? '<' : '>');
    cout << c << '^' << n << '\n';

    return 0;
}
