///created by Arsenii Kirillov
#ifdef DEBUG
# define _GLIBCXX_DEBUG
#endif

#include <bits/stdc++.h>
#define ff first
#define ss second
#define szof(x) ((int) (x).size())

template <typename T>
T input() {
    T res;
    std::cin >> res;
    return res;
}

template <typename IT>
void input_seq(IT b, IT e) {
    std::generate(b, e, input<typename std::remove_reference<decltype(*b)>::type>);
}

#define SZ(vec)         int((vec).size())
#define ALL(data)       data.begin(),data.end()
#define RALL(data)      data.rbegin(),data.rend()
#define TYPEMAX(type)   std::numeric_limits<type>::max()
#define TYPEMIN(type)   std::numeric_limits<type>::min()


using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const int INF = 1e9 + 123;
const ll INFL = 1e18 + 1e6;
mt19937 tw(228);
ll rnd(ll l, ll r) { return tw() % (r - l + 1) + l; }

struct dlinka
{
	vector<int> digits;
	const int limit = (int)1e9;
	dlinka(int x = 0)
	{
		digits.clear();
		digits.push_back(x);
	}
	void operator *= (const int a)
	{
		long long add = 0;
		for (int i = 0; i < (int)digits.size(); i++)
		{
			long long cur = add + (long long)digits[i] * a;
			add = cur / limit;
			digits[i] = cur % limit;
		}
		while (add)
		{
			digits.push_back(add % limit);
			add /= limit;
		}
	}
	dlinka operator + (const dlinka a)
	{
		dlinka ans(0);
		ans.digits.resize(max(digits.size(), a.digits.size()));
		int add = 0;
		for (int i = 0; i < (int)max(digits.size(), a.digits.size()); i++)
		{
			if (i < (int)digits.size())
				add += digits[i];
			if (i < (int)a.digits.size())
				add += a.digits[i];
			if (add >= limit)
			{
				ans.digits[i] = add - limit;
				add = 1;
			}
			else
			{
				ans.digits[i] = add;
				add = 0;
			}
		}
		if (add)
			ans.digits.push_back(add);
		return ans;
	}
	bool operator < (const dlinka a)const
	{
		if (digits.size() != a.digits.size())
			return digits.size() < a.digits.size();
		for (int i = digits.size() - 1; i >= 0; i--)
		{
			if (digits[i] != a.digits[i])
				return digits[i] < a.digits[i];
		}
		return false;
	}
	void print()
	{
		for (int i = digits.size() - 1; i >= 0; i--)
		{
			if (i + 1 < (int)digits.size())
			{
				int kek = 1;
				for (int j = 0; j < 8; j++)
					kek *= 10;
				for (int j = 0; j < 8; j++)
				{
					if (digits[i] < kek)
						cerr << 0;
					kek /= 10;
				}
			}
			cerr << digits[i];
		}
		cerr << "\n";
	}
};

dlinka poww(int a, int n)
{
	dlinka ans(1);
	for (int i = 0; i < n; i++)
		ans *= a;
	return ans;
}

void print(int a, int b, int c, int n)
{
	if (max(a, b) >= c)
		cout << a << "^" << n << "+" << b << "^" << n << ">" << c << "^" << n << "\n";
	else if (a + b <= c)
		cout << a << "^" << n << "+" << b << "^" << n << "<" << c << "^" << n << "\n";
	else
	{
		auto aa = poww(a, n);
		auto bb = poww(b, n);
		auto ab = aa + bb;
		auto cc = poww(c, n);
		if (a == 668 && b == 3 && 668 <= c && c <= 670)
		{
			aa.print();
			bb.print();
			ab.print();
			cc.print();
		}
		if (ab < cc)
			cout << a << "^" << n << "+" << b << "^" << n << "<" << c << "^" << n << "\n";
		else
			cout << a << "^" << n << "+" << b << "^" << n << ">" << c << "^" << n << "\n";
	}
	/*
	else if (poww(a, n) + poww(b, n) < poww(c, n))
		cout << a << "^" << n << "+" << b << "^" << n << "<" << c << "^" << n << "\n";
	else
		cout << a << "^" << n << "+" << b << "^" << n << ">" << c << "^" << n << "\n";
	//*/
}

int cur[4];
int mx;

void get_next()
{
	for (int i = 3; i >= 0; i--)
	{
		if (cur[i] < mx)
		{
			cur[i]++;
			bool d = 1;
			for (int j = 0; j <= i; j++)
				if (cur[j] == mx)
					d = 0;
			for (int j = i + 1; j < 4; j++)
				cur[j] = (j == 3) ? 3 : 1;
			if (d)
				cur[3] = mx;
			return;
		}
	}
	mx++;
	cur[0] = cur[1] = cur[2] = 1;
	cur[3] = mx;
	return;
}

long long dp[(int)4e4 + 10][5][2];

void solve() {		
	long long le, ri;
	cin >> le >> ri;
	le--;
	int cnt = ri - le;
	//get first
	for (int i = 3; i <= (int)4e4; i++)
	{
		dp[i][4][0] = 1;
		dp[i][4][1] = 0;
		for (int j = 3; j >= 0; j--)
		{
			int mn = (j == 3) ? 3 : 1;
			dp[i][j][0] += (i - mn + 1) * dp[i][j + 1][0];
			dp[i][j][1] += (i - mn) * dp[i][j + 1][1] + dp[i][j + 1][0];
		}
	}
	for (mx = 3; dp[mx][0][1] <= le; mx++)
		le -= dp[mx][0][1];
	int q = 1;
	for (int i = 0; i < 4; i++)
	{
		for (cur[i] = (i == 3) ? 3 : 1; cur[i] < mx && dp[mx][i + 1][q] <= le; cur[i]++)
			le -= dp[mx][i + 1][q];
		if (cur[i] == mx)
			q = 0;
	}
	//printing
	for (int i = 0; i < cnt; i++)
	{
		print(cur[0], cur[1], cur[2], cur[3]);
		get_next();
	}
}

int main() {
    cout << fixed << setprecision(15);
    cerr << fixed << setprecision(15);
    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    int t = 1;
    // cin >> t;
    for (int i = 0; i < t; ++i) {
        solve();
    }

#ifdef LOCAL
    cerr << "time: " << clock() * 1000 / CLOCKS_PER_SEC << endl;
#endif
    return 0;
}