#include<bits/stdc++.h>

using namespace std;

#define x first
#define y second
#define ll long long
#define ld long double
#define pb push_back

const long double EPS = 1e-9;

const ll N = 1e5 + 5, inf = 1e9 + 10, mod = 1e9 + 7;
class Line
{
    ll A,B,C;
public:
    Line(pair<ll,ll> point1,pair<ll,ll> point2)
    {
        A=(point2.second-point1.second);
        B=point1.x-point2.x;
        C=point1.y*point2.x-point1.x*point2.y;
    }
    pair<ld,ld> getpoint(Line line)
    {
        ld x,y;
        if(line.A==0)return line.getpoint(*this);
        if(A==0)
        {
            y=(-(ld)C)/(ld)B;
            x=(-(ld)line.C-(ld)line.B*y)/(ld)(line.A);
        }
        else
        {
            ll a=A*line.A/__gcd(A,line.A);
            ll b=B*a/A-line.B*a/line.A;
            ll c=C*a/A-line.C*a/line.A;
            if(b==0)return {inf,inf};
            y=(-(ld)c)/(ld)b;
            x=(-(ld)C-(ld)(B*y))/((ld)A);
        }
        return {x,y};
    }
};
void c(ll& A, ll& B, ll& C, pair<pair<ll, ll>, pair<ll, ll>> a){
    A = a.x.y - a.y.y;
    B = a.y.x - a.x.x;
    C = A*a.x.x + B*a.x.y;
}
pair<ld, ld> solve(pair<pair<ll, ll>, pair<ll, ll>> a, pair<pair<ll, ll>, pair<ll, ll>> b){
    ll A, B, C, A1, B1, C1;
    c(A, B, C, a);
    c(A1, B1, C1, b);
    if(A*B1 - A1*B == 0 || B*A1 - B1*A == 0)
        return {inf, inf};
    else
        return {(ld)(C1*B - B1*C) / (ld)(B*A1 - B1*A), (ld)(C1*A - A1*C) / (ld)(A*B1 - A1*B)};
}

bool check(pair<pair<ll, ll>, pair<ll, ll>> a, pair<pair<ll, ll>, pair<ll, ll>> b){
    Line line1(a.x,a.y),line2(b.x, b.y);
    pair<ld, ld> s;
    s = line1.getpoint(line2);
   /// cout << s.x << " " << s.y << endl;
    if(fabs(s.x - inf) <= EPS || ((s.x < a.x.x && a.y.x > a.x.x) || (s.x > a.x.x && a.y.x < a.x.x)) || s.y > max(b.x.y, b.y.y) || s.y < min(b.x.y, b.y.y))
        return false;
    else
        return true;
}

signed main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    while(n--){
        pair<pair<ll, ll>, pair<ll, ll>> a, b, v;
        cin >> a.x.x >> a.x.y >> a.y.x >> a.y.y >> b.x.x >> b.x.y >> b.y.x >> b.y.y >> v.y.x >> v.y.y;
        if(check({a.x ,{v.y.x + a.x.x, v.y.y + a.x.y}}, b) || check({a.y ,{v.y.x + a.y.x, v.y.y + a.y.y}}, b) ||
           check({b.x ,{-1*v.y.x + b.x.x, -1*v.y.y + b.x.y}}, a) || check({b.y ,{-1*v.y.x + b.y.x, -1*v.y.y + b.y.y}}, a))
            cout << "Yes\n";
        else
            cout << "No\n";
    }
}
/*
5
0 2 1 1 2 2 3 1 1 1
0 2 1 1 2 2 3 1 -1 -1
1 1 1 3 2 1 2 3 1 0
1 1 1 3 2 1 2 3 0 1
4 1 0 2 3 2 2 3 1 3
*/
