#pragma GCC optimize("O3")
#pragma GCC target("sse,sse2,sse3,ssse3,mmx")

#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>
#include<ext/pb_ds/tree_policy.hpp>

#define ll long long
#define cdbg cerr << "Debug in " << __func__ << ", " << __LINE__ <<": "
#define q << '\n'
#define sp << ' '
#define ft first
#define sd second
#define pii pair<int, int>
#define vi vector<int>
#define pb emplace_back
#define mp make_pair
#define ull unsigned long long
#define ld long double
#define ordered_set tree<ll,null_type,less<ll>,rb_tree_tag,tree_order_statistics_node_update>
#define y1 trymaxlox
using namespace std;
using namespace __gnu_pbds;

//ordered_set a;
ld eps = 1e-9;
struct pt
{
    ld x;
    ld y;
    pt()
    {

    }
    pt(ld a, ld b)
    {
        x = a;
        y = b;
    }
};
struct line
{
    pt ft;
    pt sd;
    ld k;
    ld b;
    line(pt a, pt b)
    {
        ft = a;
        sd = b;
    }
    line(pt a, pt bbb, ld kk, ld bb)
    {
        ft = a;
        sd = bbb;
        k = kk;
        b = bb;
    }
};

line get_line(line ln)
{
    ld k, b;
    if (abs(ln.ft.x - ln.sd.x) < eps)
    {
        k = INFINITY;
        b = INFINITY;
        return line(ln.ft, ln.sd, k, b);
    }
    k = (ln.ft.y - ln.sd.y)/(ln.ft.x - ln.sd.x);
    b = ln.ft.y - ln.ft.x*k;
    return line(ln.ft, ln.sd, k, b);
}

ld min(ld a, ld b)
{
    if (a-eps < b)
    {
        return a;
    }
    return b;
}
ld max(ld a, ld b)
{
    if (b-eps < a)
    {
        return a;
    }
    return b;
}
int paralelny_abo_keknyti(line a, line b)
{
    if (a.k == INFINITY && b.k == INFINITY)
    {
        if ((a.ft.x == b.ft.x))
        {
            if (min(a.ft.y, a.sd.y) > max(b.ft.y, b.sd.y)) return 1;
            if (min(b.ft.y, b.sd.y) > max(a.ft.y, a.sd.y)) return 1;
            return 2;
        }
        else return 1;
    }
    if (abs(a.k - b.k) < eps)
    {
        if (!(abs(a.b - b.b) < eps)) return 1;
        if (min(a.ft.x, a.sd.x) > max(b.ft.x, b.sd.x)) return 1;
        if (min(b.ft.x, b.sd.x) > max(a.ft.x, a.sd.x)) return 1;

        return 2;
    }
    return 0;
}
pt get_pt(line a, line b)
{
    pt res;
   // cdbg << a.b sp << a.k sp << b.b sp << b.k sp << (b.b - a.b) sp << (b.k - a.k) sp << ((b.b - a.b)/(b.k - a.k)) q;
    res.x = ((b.b - a.b)/(a.k - b.k));
    res.y = a.k*res.x + a.b;
    return res;
}
ll x1, x2, x3,x4 ,y1,y2,y3,y4, vx,vy;
bool leseq(ld a, ld b)
{
    if (abs(a-b) < eps) return 1;
    if (b - a > -eps) return 1;
    return 0;
}
bool greq(ld a, ld b)
{
    if (abs(a-b) < eps) return 1;
    if (a - b > -eps) return 1;
    return 0;
}
main()
{
    ll n;
   // cout << log2(1000) q;
    cin >> n;
    while (n--)
    {
        cin >> x1 >> y1 >> x2 >> y2 >> x3 >> y3 >> x4 >> y4 >> vx >> vy;
        x1 += vx;
        x2 += vx;
        y1 += vy;
        y2 += vy;
        line a = get_line(line(pt(x1, y1), pt(x2, y2)));
        line b = get_line(line(pt(x3, y3), pt(x4, y4)));
        int res = paralelny_abo_keknyti(a, b);
        if (res == 2)
        {
            cout << "Yes" q;
        }
        else if (res == 1)
        {
            cout << "No" q;
        }
        else
        {
          //  cdbg << "ne paralelny" q;
            pt A = get_pt(a,b);
            bool f = 0, ff = 0;
          //  cdbg << A.x sp << A.y q;
            if (leseq(a.ft.x, A.x) && greq(a.sd.x, A.x))
            {
                if ((leseq(b.ft.x, A.x) && greq(b.sd.x, A.x)) || (leseq(b.sd.x, A.x) && greq(b.ft.x, A.x)))
                {
                    f = 1;
                }
                else f = 0;
            }
            else if (leseq(a.sd.x, A.x) && greq(a.ft.x, A.x))
            {
                if ((leseq(b.ft.x, A.x) && greq(b.sd.x, A.x)) || (leseq(b.sd.x, A.x) && greq(b.ft.x, A.x)))
                {
                    f = 1;
                }
                else f = 0;
            }
            else f = 0;

            if (leseq(a.ft.y, A.y) && greq(a.sd.y, A.y))
            {
                if ((leseq(b.ft.y, A.y) && greq(b.sd.y, A.y)) || (leseq(b.sd.y, A.y) && greq(b.ft.y, A.y)))
                {
                    ff = 1;
                }
                else ff = 0;
            }
            else if (leseq(a.sd.y, A.y) && greq(a.ft.y, A.y))
            {
                if ((leseq(b.ft.y, A.y) && greq(b.sd.y, A.y)) || (leseq(b.sd.y, A.y) && greq(b.ft.y, A.y)))
                {
                    ff = 1;
                }
                else ff = 0;
            }
            else ff = 0;
            if (f && ff) cout << "Yes" q;
            else cout << "No" q;
        }

    }














///2 3 4 6 2 1 5 -1 0 4



















}
