#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

vector <int> prec[1007][1007];
const ll B = (1ll << 50);

vector <ll> mul(vector <ll> a, ll x) {
	ll um = 0;
	for (int i = 0; i < (int) a.size() || um; i++) {
		if (i >= (int) a.size()) a.push_back(0);
		ll cur = (a[i] * (ll) x + um) % B;
		um = (a[i] * (ll) x + um) / B;
		a[i] = cur;
	}
	return a;
}

vector <ll> ans;

void add(vector <ll> &a, vector <ll> &b) {
	ll um = 0;
	ans.clear();
	for (int i = 0; i < (int) a.size() || i < (int) b.size() || um; i++) {
		if (i >= a.size()) a.push_back(0);
		if (i >= b.size()) b.push_back(0);
		ll go = (a[i] + b[i] + um) % B;
		um = (a[i] + b[i] + um) / B;
		ans.push_back(go);
	}
}

int cmp(vector <ll> &a, vector <ll> &b) {
	while (!a.empty() && a.back() == 0) a.pop_back();
	while (!b.empty() && b.back() == 0) b.pop_back();
	if (a.size() < b.size()) return -1;
	if (a.size() > b.size()) return 1;
	reverse(a.begin(), a.end());
	reverse(b.begin(), b.end());
	int ans = (a < b ? -1 : 1);
	reverse(a.begin(), a.end());
	reverse(b.begin(), b.end());
	return ans;
}

vector <ll> f(int a, int b) {
	vector <ll> cur = {1};
	for (int i = 0; i < b; i++) {
		cur = mul(cur, a);
	}
	return cur;
}

vector <int> arr;

bool vis[5][2];
ll mem[5][2];
ll mx;

ll gen(int i, bool enough) {
	if (vis[i][enough]) return mem[i][enough];
	vis[i][enough] = true;
	if (i == 4) {
		return mem[i][enough] = enough;
	} else {
		ll cur = 0;
		if (i == 3) {
			cur += gen(i + 1, enough) * (mx - 3);
			cur += gen(i + 1, true);
		} else {
			cur += gen(i + 1, enough) * (mx - 1);
			cur += gen(i + 1, true);
		}
		return mem[i][enough] = cur;
	}
}

ll l, r;

int last = -1;

vector <ll> pa, pb, pc;

int its = 0;

void restore(int i, bool enough) {
	its++;
	assert(its <= 2000000);
	if (!r) return;
	if (gen(i, enough) < l) {
		l -= gen(i, enough), r -= gen(i, enough);
		return;
	}
	if (i == 4) {
		last = arr[0];
	//	f(arr[0], arr[3]);
		//f(arr[1], arr[3]);
		//f(arr[2], arr[3]);
		int go = 1;
		if (arr[0] < arr[2] && arr[1] < arr[2]) {
			add(pa, pb);
			go = cmp(ans,pc);
		}
		cout << arr[0] << '^' << arr[3] << '+' << arr[1] << '^' << arr[3] << (go == -1 ? '<' : '>') << arr[2] << '^' << arr[3] << '\n';
		r--;
	} else {
		ll cur = 0;
		ll go = gen(i + 1, enough);
		if (go) {
			if (i == 3) {
				ll need = (l - 1) / go;
				if (need < 0) need = 0;
				if (need > mx - 3) need = mx - 3;
				l -= go * need, r -= go * need;
				if (3 + need <= mx) {
					if (arr[0] < arr[2] && arr[1] < arr[2]) 
						pa = f(arr[0], 3 + need), pb = f(arr[1], 3 + need), pc = f(arr[2], 3 + need);
					for (ll x = 3 + need; x < mx; x++) {
						arr.push_back(x);
						restore(i + 1, enough);
						arr.pop_back();
						if (arr[0] < arr[2] && arr[1] < arr[2]) {
							pa = mul(pa, arr[0]);
							pb = mul(pb, arr[1]);
							pc = mul(pc, arr[2]);
						}
						if (!r) break;
					}
				}
			} else {
				ll need = (l - 1) / go;
				if (need < 0) need = 0;
				if (need > mx - 1) need = mx - 1;
				l -= go * need, r -= go * need;
				for (ll x = 1 + need; x < mx; x++) {
					arr.push_back(x);
					restore(i + 1, enough);
					arr.pop_back();
					if (!r) break;
				}
			}
		}
		if (i == 3) {
			if (arr[0] < arr[2] && arr[1] < arr[2])
				pa = f(arr[0], mx), pb = f(arr[1], mx), pc = f(arr[2], mx);
		}
		arr.push_back(mx);
		restore(i + 1, true);
		arr.pop_back();
	}
}

mt19937 rnd(228);

int main() {
		cin >> l >> r;
		for (mx = 3; mx <= 1005; mx++) {
			for (int i = 0; i <= 4; i++) for (int t = 0; t < 2; t++) {
				vis[i][t] = 0;
			}
			restore(0, false);
		}
}
