#include <bits/stdc++.h>

#define ll long long
#define pb push_back
#define ft first
#define sd second
#define ld double
#define int long long

//#pragma GCC optimize("fast-math")
//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,tune=native")

using namespace std;
const ll mod = (ll)1e9+7;
const ll inf = (ll)1e16;
const ld eps = 1e-7;

bool line_to_seq(ll l1, ll l2, ll l3, ll ax, ll ay, ll bx, ll by,ll tx,ll ty,ll kx,ll ky) {
    ll b1 = -(bx-ax);
    ll a1 = by-ay;
    ll c1 = -(a1*ax+b1*ay);

    if (l1*c1-a1*l3 == 0 && a1*l2-b1*l1==0) {
        if (min(tx,kx) <= ax && ax <= max(tx,kx)) {
            if (min(ty,ky) <= ay && ay <= max(ty,ay)) {
                return 1;
            }
        }

        if (min(tx,kx) <= bx && bx <= max(tx,kx)) {
            if (min(ty,ky) <= by && by <= max(ty,ay)) {
                return 1;
            }
        }
        return 0;
    }


    if (a1*l2-b1*l1==0)
        return 0;

    ld y = (ld)(l1*c1-a1*l3)/(ld)(a1*l2-b1*l1);
    ld x = -(ld)(c1+b1*y)/(ld)a1;

    if (min(tx,kx) <= x && x<= max(tx,kx)) {
        if (min(ty,ky) <= x && y<= max(ty,ky)) {
            if (min(ax, bx) <= x && x <= max(ax, bx)) {
                if (min(ay, by) <= y && y <= max(ay, by)) {
                    return 1;
                }
            }
        }
    }

    return 0;
}

int32_t main() {

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    ll n;

    cin >> n;

    for (ll i = 0; i < n; i++) {
        ll ax,ay,bx,by,cx,cy,dx,dy,vx,vy;

        cin >> ax >> ay >> bx >> by >> cx >> cy >> dx >> dy >> vx >> vy;

        ll l1 = -vy;
        ll l2 = vx;
        ll l3 = -(l1*ax+l2*ay);

        ll kx = inf;
        ll ky = inf;

        if (vx < 0)
            kx = -kx;

        if (vy < 0)
            ky = -ky;

        if (line_to_seq(l1,l2,l3,cx,cy,dx,dy,ax,ay,kx,ky)) {
            cout << "Yes\n";
            continue;
        }
        l3 = -(l1*bx+l2*by);

        if (line_to_seq(l1,l2,l3,cx,cy,dx,dy,bx,by,kx,ky)) {
            cout << "Yes\n";
            continue;
        }

        cout << "No\n";
    }
    return 0;
}