#include <bits/stdc++.h>
#pragma GCC optimize("avx2")
//#define int long long
#define F first
#define S second

using namespace std;
const int maxn = 502;

vector<int> g[maxn][maxn];
bitset<maxn> v[maxn][maxn];
bitset<maxn> xr[maxn][maxn];
short lc[maxn][maxn][maxn];
int ck = 0;

vector<int> calc_lca(int x, int pr) {
    vector<int> cv;
    cv.push_back(x);
    lc[ck][x][x] = x;
    for (int i = 0; i < g[ck][x].size(); i++) {
        int to = g[ck][x][i];
        if (to == pr) continue;
        vector<int> cs = calc_lca(to, x);
        if (cs.size() > cv.size())
            swap(cv, cs);
        for (auto tt : cs)
            for (int j = 0; j < cv.size(); j++)
                lc[ck][tt][cv[j]] = lc[ck][cv[j]][tt] = x;
        for (auto tt : cs)
            cv.push_back(tt);
    }
    return cv;
}

void dfs(int x, int pr) {
    if (pr != -1) xr[ck][x] = xr[ck][pr];
    xr[ck][x][x] = 1;
    for (int i = 0; i < g[ck][x].size(); i++) {
        if (g[ck][x][i] == pr) continue;
        dfs(g[ck][x][i], x);
    }
}

signed main() {
    int n, k;
    cin >> n >> k;
    for (int j = 0; j < k; j++) {
        for (int i = 0; i < n - 1; i++) {
            int u, v;
            cin >> u >> v;
            g[j][u - 1].push_back(v - 1);
            g[j][v - 1].push_back(u - 1);
        }
    }
    for (ck = 0; ck < k; ck++)
        calc_lca(0, -1);
    for (ck = 0; ck < k; ck++)
        dfs(0, -1);
    for (int i = 0; i < n; i++)
        for (int j = i + 1; j < n; j++)
            for (int l = 0; l < n; l++)
                v[i][j][l] = 1;
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            for (int l = 0; l < k; l++) {
                xr[l][i][lc[l][i][j]] = 0;
                v[i][j] &= xr[l][i] ^ xr[l][j];
                xr[l][i][lc[l][i][j]] = 1;
            }
        }
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++)
            if (i == j) cout << "1 ";
            else if (v[i][j].count() == 0) cout << v[j][i].count() << ' ';
            else cout << v[i][j].count() << ' ';
        cout << '\n';
    }
}
