#include<bits/stdc++.h>
//#define int long long

using namespace std;

struct Point{
    int x, y;
    Point(int x1 = 0, int y1 = 0){
        x = x1;
        y = y1;
    }

    void input(){
        cin >> x >> y;
    }

    void outout(){
        cout << x << ' ' << y << endl;
    }
};

struct Vector{
    int x, y;
    Vector(Point a = Point(), Point b = Point()){
        x = b.x - a.x;
        y = b.y - a.y;
    }

    void input(){
        cin >> x >> y;
    }

    int cross_product(Vector v){
        return x * v.y - y * v.x;
    }

    int dot_product(Vector v){
        return x * v.x + y * v.y;
    }
};

int check(Point a, Point b, Point c, Vector v){
    Vector f(a, b), s(a, c);
    int t1 = v.cross_product(f), t2 = v.cross_product(s), t3 = v.dot_product(f), t4 = v.dot_product(s);
    /*
    cout << "The first point: ";
    a.outout();
    cout << "The second point: ";
    b.outout();
    cout << "The third point: ";
    c.outout();
    cout << "Productions: " << t1 << ' ' << t2 << endl;
    cout << "----End----" << endl;
    */
    if(t3 < 0 || t4 < 0)
        return 2;
    if(t1 == 0 || t2 == 0)
        return 0;
    if(t1 >= 0){
        if(t2 >= 0)
            return 1;
        return 0;
    }
    if(t2 <= 0)
        return -1;
    return 0;
}

void solve() {
    Point a, b, c, d;
    Vector v;
    a.input();
    b.input();
    c.input();
    d.input();
    v.input();
    int c1 = check(a, c, d, v), c2 = check(b, c, d, v);
    //cout << c1 << ' ' << c2 << endl;
    if(c1 == 2 && c2 == 2){
        cout << "No\n";
        return;
    }
    if(c1 == 2 || c2 == 2){
        cout << "Yes\n";
        return;
    }
    if(c1 * c2 <= 0)
        cout << "Yes\n";
    else
        cout << "No\n";
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
