#include <iostream>
#include <vector>

int n;

using namespace std;

string to_str(int x1, int y1) {
    string s = "00";
    s[0] = 'a' + y1;
    s[1] = '1' + x1;
    return s;
}

vector <string> ans;

void add(int x1, int y1, int x2, int y2, int x3, int y3) {
    string res = to_str(x1, y1) + " > " + to_str(x2, y2) + " ? " + to_str(x3, y3);
    ans.push_back(res);
}

void swap0(int x1, int y1, int x2, int y2) {
    add(x1, y1, x2, y2, x1 - 1, y1);
    y1++;
    x2--;
    add(x1, y1, x2, y2, x2 - 1, y2 - 1);
    x2--;
    add(x1, y1, x2, y2, x2, y2 - 1);
    y2--;
    add(x1, y1, x2, y2, x1 - 1, y1 - 1);
    x1--;
    add(x1, y1, x2, y2, x1, y1 - 1);
    y1--;
    add(x1, y1, x2, y2, x1, y1);
    x1++;
    add(x1, y1, x2, y2, x2, y2);
    x2++;
    add(x1, y1, x2, y2, x2, y2);
    x2++;
    y1++; 
    //cout << x1 << ' ' << y1 << ' ' << x2 << ' ' << y2 << endl;
}

void swap1(int x1, int y1, int x2, int y2) {
    add(x1, y1, x2, y2, x2 - 1, y2);
    y2++;
    add(x1, y1, x2, y2, x2 - 1, y2 - 1);
    x2--;
    add(x1, y1, x2, y2, x2, y2 - 1);
    y2--;
    while (y2 < y1 - 1) {
        add(x1, y1, x2, y2, x1 - 1, y1 - 1);
        x1--;
        add(x1, y1, x2, y2, x1, y1 - 1);
        y1--;
        add(x1, y1, x2, y2, x1, y1);
        x1++;
    }
    add(x1, y1, x2, y2, x1 - 1, y1 - 1);
    x1--;
    y2++;
    add(x1, y1, x2, y2, x1, y1 - 1);
    y1--;
    x2--;
    add(x1, y1, x2, y2, x1, y1);
    x1++;
    y2--;
    //x2--;
    //cout << x1 << ' ' << y1 << ' ' << x2 << ' ' << y2 << endl;
    add(x1, y1, x2, y2, x1, y1);
    x1++;
    /*add(x1, y1, x2, y2, x1, y1 - 1);
    y1--;
    add(x1, y1, x2, y2, x1, y1);
    x1++;
    add(x1, y1, x2, y2, x1 - 1, y1);
    y1++;*/
    add(x1, y1, x2, y2, x2, y2);
    x2++;
    while (y2 < n - 1) {
        add(x1, y1, x2, y2, x2 - 1, y2);
        y2++;
    }
    //cout << x1 << ' ' << y1 << ' ' << x2 << ' ' << y2 << endl;
}

int main() {
    /*n = 4;
    swap1(2, 3, 3, 0);
    cout << ans.size() << endl;
    for (string elem : ans) cout << elem << endl;
    return 0;*/
    cin >> n;
    if (n == 2) return 0;
    int all = n * (n - 2);
    for (int t = 0; t < all; t++) {
        for (int i = 0; i < all - 1; i++) {
            int j = i + 1;
            int x1 = i / n + 2, y1 = i % n, x2 = j / n + 2, y2 = j % n;
            if (x1 == x2) swap0(x1, y1, x2, y2);
            else swap1(x1, y1, x2, y2);
        }
    }
    //cout << ans.size() << endl;
    for (string elem : ans) {
        cout << elem << "\n";
    }
    return 0;
}
