#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;
#define F first
#define S second
#define pb push_back
#define all(x) (x).begin(), (x).end()
#define SZ(x) (int)x.size()
//#define int ll

const int N = 510;
vector<short> g[N][N];
vector<short> sub[N];
short lca[N][N][N], h[N][N];
int tin[N][N], tout[N][N], comm[N][N], ans[N][N], pr[N], timer;

void dfs(int id, int v, int p = 0, int curh = 0) {
    sub[v].pb(v);
    h[id][v] = curh;
    tin[id][v] = ++timer;
    if (id == 1) {
        pr[v] = p;
    }
    for (int u : g[id][v]) {
        if (u != p) {
            dfs(id, u, v, curh + 1);
            for (int k : sub[u]) {
                for (int k2 : sub[v]) {
                    lca[id][k][k2] = lca[id][k2][k] = v;
                }
            }
            for (int k : sub[u]) {
                sub[v].pb(k);
            }
        }
    }
    tout[id][v] = ++timer;
}

bool anc(int id, int a, int b) {
    return tin[id][a] <= tin[id][b] && tout[id][a] >= tout[id][b];
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    //freopen("input.txt", "r", stdin);
    int n, k;
    cin >> n >> k;
    for (int i = 1; i <= k; i++) {
        for (int j = 1; j < n; j++) {
            int u, v;
            cin >> u >> v;
            g[i][u].pb(v);
            g[i][v].pb(u);
        }
    }
    for (int i = 1; i <= k; i++) {
        dfs(i, 1);
        for (int j = 1; j <= n; j++) {
            sub[j] = {};
        }
    }
    vector<pair<int, pair<int, int> > > order;
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= n; j++) {
            int d = h[1][i] + h[1][j] - 2 * h[1][lca[1][i][j]];
            //cout << i << ' ' << j << ' ' << d << '\n';
            if (d >= 2) {
                order.pb(make_pair(d, make_pair(i, j)));
            }
        }
    }
    for (int i = 1;i <= n; i++) {
        for (int j = 1; j <= n; j++) {
            comm[i][j] = -1;
            if (i == j) {
                ans[i][j] = 1;
            }
            else {
                ans[i][j] = 2;
            }
        }
    }
    sort(all(order));
    for (auto it : order) {
        int u = it.S.F, v = it.S.S, l = lca[1][u][v];
        int w, flag;
        if (pr[u] != 0 && anc(1, l, pr[u])) {
            w = pr[u];
            flag = 1;
        }
        else {
             w = pr[v];
             flag = 2;
        }
        //cout << u << ' ' << v << ' ' << w << '\n';
        bool ok = true;
        for (int j = 2; j <= k; j++) {
            if (!((anc(j, w, u) || anc(j, w, v)) && anc(j, lca[j][u][v], w))) {
                ok = false;
                break;
            }
        }
        if (ok) {
            comm[u][v] = w;
        }
        else {
            if (flag == 1) {
                comm[u][v] = comm[w][v];
            }
            else {
                comm[u][v] = comm[w][u];
            }
        }
        //cout << "KEK " << u << ' ' << v << ' ' << comm[u][v] << '\n';
        if (comm[u][v] != -1) {
            ans[u][v] = ans[comm[u][v]][u] + ans[comm[u][v]][v] - 1;
        }
    }
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= n; j++) {
            cout << ans[i][j] << ' ';
        }
        cout << '\n';
    }
}


