#include <bits/stdc++.h>

using namespace std;

#define int long long
const int inf = 1e9;

int vec_prod(pair<int, int> a, pair<int, int> b){
    return a.first * b.second - a.second * b.first;
}

int scal_prod(pair<int, int> a, pair<int, int> b){
    return a.first * b.first + a.second * b.second;
}

const long double MPI = 3.1415926535897932384626433832795;

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    int n;
    cin >> n;
    for(int c=0; c<n; c++){
        pair<int, int> a1, a2;
        pair<int, int> b1, b2;
        cin >> a1.first >> a1.second;
        cin >> a2.first >> a2.second;
        cin >> b1.first >> b1.second;
        cin >> b2.first >> b2.second;

        pair<int, int> vec;
        cin >> vec.first >> vec.second;

        pair<int, int> vec1 = {b1.first - a1.first, b1.second - a1.second};
        pair<int, int> vec2 = {b2.first - a1.first, b2.second - a1.second};
        /*
        cout << fixed << setprecision(10) << abs(atan2(vec_prod(vec, vec1), scal_prod(vec, vec1))) + abs(atan2(vec_prod(vec, vec2), scal_prod(vec, vec2))) << endl;
        cout << fixed << setprecision(10) << MPI << endl;
        */
        if((scal_prod(vec, vec1) >= 0 || scal_prod(vec, vec2) >= 0) && abs(atan2(vec_prod(vec, vec1), scal_prod(vec, vec1))) + abs(atan2(vec_prod(vec, vec2), scal_prod(vec, vec2))) <= MPI){
            bool b1 = false, b2 = false;
            if(vec_prod(vec, vec1) <= 0)b1 = true;
            if(vec_prod(vec, vec1) >= 0)b2 = true;
            if(vec_prod(vec, vec2) <= 0)b1 = true;
            if(vec_prod(vec, vec2) >= 0)b2 = true;
            if(b1 && b2){
                cout << "Yes\n";
                //cout << endl;
                continue;
            }


        }

        vec1 = {b1.first - a2.first, b1.second - a2.second};
        vec2 = {b2.first - a2.first, b2.second - a2.second};
        if((scal_prod(vec, vec1) >= 0 || scal_prod(vec, vec2) >= 0) && abs(atan2(vec_prod(vec, vec1), scal_prod(vec, vec1))) + abs(atan2(vec_prod(vec, vec2), scal_prod(vec, vec2))) <= MPI){
            bool b1 = false, b2 = false;
            if(vec_prod(vec, vec1) <= 0)b1 = true;
            if(vec_prod(vec, vec1) >= 0)b2 = true;
            if(vec_prod(vec, vec2) <= 0)b1 = true;
            if(vec_prod(vec, vec2) >= 0)b2 = true;
            if(b1 && b2){
                cout << "Yes\n";
                //cout << endl;
                continue;
            }
        }

        vec1 = {b1.first - a2.first, b1.second - a2.second};
        vec2 = {b2.first - a2.first, b2.second - a2.second};
        pair<int, int> vec3 = {b1.first - a1.first, b1.second - a1.second};
        pair<int, int> vec4 = {b2.first - a1.first, b2.second - a1.second};
        if(vec_prod(vec, vec1) > 0 && vec_prod(vec, vec2) > 0 && vec_prod(vec, vec3) < 0 && vec_prod(vec, vec4) < 0){
            pair<int, int> dop = {a2.first - a1.first, a2.second - b2.second};
            if(vec_prod(dop, vec4) > 0){
                cout << "Yes\n";
                //cout << endl;
                continue;
            }
        }
        if(vec_prod(vec, vec1) < 0 && vec_prod(vec, vec2) < 0 && vec_prod(vec, vec3) > 0 && vec_prod(vec, vec4) > 0){
            pair<int, int> dop = {a2.first - a1.first, a2.second - b2.second};
            if(vec_prod(dop, vec4) < 0){
                cout << "Yes\n";
                //cout << endl;
                continue;
            }
        }
        cout << "No\n";
        //cout << endl;
    }
    return 0;
}

/*

1
0 0 1 1
-1 -1
1 2
1 1

2
0 2 1 1 2 2 3 1 1 1
0 2 1 1 2 2 3 1 -1 -1

1
0 0 10 0 4 2 8 2 0 10

1
4 2 8 2 0 0 10 0 0 10
*/
