#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <math.h>
#include <set>
#include <fstream>
#include <queue>
#include <iomanip>
#include <string>
#include <deque>

using namespace std;

typedef long long ll;

const double eps = 1e-7;

#define endl '\n'

ll D[20];
vector<pair <char, ll>> ans;

string f(string s) {
	for (ll i = 0; i < s[0] - '0' - 1; i++) {
		//cout << "+ " << D[i - 1] << '\n';
		ans.push_back({ '+',  D[s.length() - 1] });
	}
	string d;
	ll j = 1;
	while (s[j] == '1') {
		j++;
		if (j == s.length()) {
			break;
		}
	}
	ans.push_back({ '-',  j - 1 + (s[0] - '0') });
	while (s[j] == '0') {
		j++;
		if (j == s.length()) {
			break;
		}

	}
	//cout << "- " << j - 1 + (s[0] - '0') << '\n';
	for (ll i = j; i < s.length(); i++) {
		d.push_back(s[i]);
	}
	if (d.length() == 0) {
		d.push_back('0');
	}
	return d;
}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	string a, b;
	ll k;
	cin >> a >> k;
	D[0] = 1;
	cout << "Stable" << '\n';
	for (ll i = 1; i < 20; i++) {
		D[i] = D[i - 1] * 10;
	}
	b = to_string(k);
	while (a[0] != '0') {
		a = f(a);
	}
	ll ost = k % 9;
	if (b == "0") {
		cout << ans.size() << '\n';
		for (ll i = 0; i < ans.size(); i++) {
			cout << ans[i].first << " " << ans[i].second << '\n';
		}
		return 0;
	}
	if (ost != 0) {
	ans.push_back({ '+',  2 });
	//cout << "+ 2" << '\n';
	ans.push_back({ '-',  1 });
	//cout << "- 1" << '\n';
	
		for (ll i = 8; i > ost; i--) {
			ans.push_back({ '+',  1 });
			//cout << "+ 1" << '\n';
			ans.push_back({ '-',  1 });
			//cout << "- 1" << '\n';
		}
	}
	ans.push_back({ '+',  (k - ost) / 9 });
	//cout << "+ " << (k - ost) / 9;
	cout << ans.size() << '\n';
	for (ll i = 0; i < ans.size(); i++) {
		cout << ans[i].first << " " << ans[i].second << '\n';
	}
}

