#pragma GCC optimize("Ofast,no-stack-protector")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,abm,popcnt,mmx,avx,avx2,tune=native")

#include<bits/stdc++.h>
#define endl '\n'
#define forn(i, n) for (int (i) = 0; (i) < (n); ++(i))
#define all(a) (a).begin(), (a).end()
#define len(a) (int) (a).size()
using namespace std;
void solve();
signed main(){
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    solve();


    return 0;
}

const int MAXN = 507;
vector<int> g[MAXN][MAXN];
bitset<MAXN> dp[MAXN][MAXN];
int p[MAXN][MAXN], d[MAXN][MAXN], n, k;
int mem[MAXN][MAXN];
bitset<MAXN> intr[MAXN][MAXN];

void dfs(int i, int v) {
    dp[i][v][v] = 1;

    for(auto& u: g[i][v]) {
        if(u == p[i][v]) continue;

        p[i][u] = v;
        d[i][u] = d[i][v] + 1;
        dp[i][u] ^= dp[i][v];
        dfs(i, u);
    }
}

int LCA(int i, int v, int u) {
    if(mem[v][u] == -1) {
        if(v == u) {
            mem[v][u] = v;
        } else if(d[i][v] > d[i][u]) {
            mem[v][u] = LCA(i, p[i][v], u);
        } else if(d[i][v] < d[i][u]) {
            mem[v][u] = LCA(i, v, p[i][u]);
        } else {
            mem[v][u] = LCA(i, p[i][v], p[i][u]);
        }
    }

    return mem[v][u];
}

void init_tree(int i) {
    for(int v = 0; v < n; ++v) {
        p[i][v] = -1;
    }

    for(int j = 0; j < n - 1; ++j) {
        int v, u; cin >> v >> u; --v, --u;
        g[i][v].push_back(u);
        g[i][u].push_back(v);
    }

    dfs(i, 0);

    for(int i = 0; i < n; ++i) {
        for(int j = 0; j < n; ++j) {
            mem[i][j] = -1;
        }
    }

    for(int v = 0; v < n; ++v) {
        for(int u = 0; u < v; ++u) {
            int w = LCA(i, v, u);
            bitset<MAXN> cur = dp[i][v] ^ dp[i][u];
            cur[w] = 1;

            intr[v][u] &= cur;
        }
    }
}

void solve() {
    cin >> n >> k;

    for(int i = 0; i < n; ++i) {
        for(int j = 0; j < i; ++j) {
            intr[i][j].set();
        }
    }

    for(int i = 0; i < k; ++i) {
        init_tree(i);
    }

    for(int v = 0; v < n; ++v) {
        for(int u = 0; u < v; ++u) {
            cout << intr[v][u].count() << ' ';
        }

        cout << "1 ";

        for(int u = v + 1; u < n; ++u) {
            cout << intr[u][v].count() << ' ';
        }

        cout << '\n';
    }
}

/*
4 2
1 3
4 2
3 4
1 4
4 3
2 4
 */