#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/detail/standard_policies.hpp>

#define forn(i, n) for (int i = 0; i < n; ++i)

using namespace std;
using namespace __gnu_pbds;

#ifdef DEBUG
#define io freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout)
#else
#define io ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)
#endif

#define all(a) a.begin(), a.end()

typedef long long ll;
typedef long double ld;
typedef tree<
        int,
        null_type,
        less<int>,
        rb_tree_tag,
        tree_order_statistics_node_update>
        ordered_set;

vector<pair<int, ll>> order;

void zero(ll a) {
    vector<int> x;
    while(a > 0) {
        x.push_back(a % 10);
        a /= 10;
    }
    while(!x.empty()) {
        a = x.back();
        x.pop_back();
        if(a == 0)
            continue;
        if(a == 1) {
            order.emplace_back(-1, 1);
            continue;
        }
        ll add = 1;
        for(int j = 0; j < x.size(); j++)
            add *= 10;
        for(int i = 0; i < a - 1; i++) {
            order.emplace_back(1, add);
            order.emplace_back(-1, 1);
        }
        order.emplace_back(-1, 1);
    }
}

void make(ll a) {
    vector<int> x;
    while(a > 0) {
        x.push_back(a % 10);
        a /= 10;
    }
    reverse(all(x));
    int u = 0;
    while(!x.empty()) {
        a = x.back();
        x.pop_back();
        if(a == 0)
            continue;
        ll add = 1;
        for(int j = 0; j < u; j++)
            add *= 10;
        order.emplace_back(1, add);
        for(; a < 9; a++) {
            order.emplace_back(1, add);
            order.emplace_back(-1, 1);
        }
        u++;
    }
}

int32_t main() {
    io;
    ll a, b;
    cin >> a >> b;
    zero(a);
    make(b);
    if(order.size() > 1000) return 1;
    cout << "Stable\n";
    cout << order.size() << "\n";
    for(auto i: order) {
        if(i.first == -1) {
            cout << "- " << i.second << "\n";
        }
        if(i.first == 1) {
            cout << "+ " << i.second << "\n";
        }
    }
}

