#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define all(aaa) aaa.begin(), aaa.end()

pair<ll, ll> getMax(ll k) {
    for (ll i = 3; i <= 2000; i++) {
        ll cur = i * i * i;
        if (cur >= k)
            return {i, k};
        k -= cur;
    }
}

ll pw(ll a, int p) {
    ll r = 1;
    while (p > 0) {
        r = r * a;
        p--;
    }
    return r;
}

vector<ll> toVec(ll tmp, ll x) {
    vector<ll> cur;
    for (int i = 0; i < 3; i++) {
        cur.push_back(tmp % x);
        tmp /= x;
    }
    reverse(all(cur));
    for (ll &x : cur)
        x++;
    cur.push_back(x);
    return cur;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

#ifdef HOME
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // HOME
    ll l, r;
    cin >> l >> r;

    auto p = getMax(l);

    ll len = r - l + 1;

    ll x = p.second - 1;

    vector<vector<ll>> v;

    while (len > 0) {
        ll ct = pw(p.first, 3);
        while (len > 0 && x < ct) {
            len--;
            v.push_back(toVec(x, p.first));
            x++;
        }
        x = 0;
        p.first++;
    }

    for (auto w : v) {
        char sign = '<';
        if (w[0] >= w[2] || w[1] >= w[2]) {
            sign = '>';
        }
        cout << w[0] << "^" << w[3] << "+" << w[1] << "^" << w[3]
            << sign << w[2] << "^" << w[3] << "\n";
    }

    return 0;
}
