#include <bits/stdc++.h>

using namespace std;

#define FOR(i, n) for (int i = 0; i < n; ++i)
#define debug(x) cout << #x << ": " << x << endl;
#define fi first
#define se second
#define mp make_pair
#define pb push_back
#define all(a) a.begin(), a.end()

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
#define int long long
template <typename T1, typename T2> bool chkmin(T1 &x, T2 y) { return y < x ? (x = y, true) : false; };
template <typename T1, typename T2> bool chkmax(T1 &x, T2 y) { return y > x ? (x = y, true) : false; };

void fast()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
}

const int N = 61;
int dp[N][N][N][2];

struct point {
    int x, y;

    point(int _x = 0, int _y = 0): x(_x), y(_y) {}

    point operator + (point p) const {
        return point(x + p.x, y + p.y);
    }
    point operator - (point p)  const {
        return point(x - p.x, y - p.y);
    }
    ll operator % (const point &p) const
    {
        return x * (ll)p.x + y * (ll)p.y;
    }
    ll operator ^ (const point &p) const
    {
        return x * (ll)p.y - y * (ll)p.x;
    }
    point operator * (int k) {
        return point(k * x, k * y);
    }

    void scan() {
        cin >> x >> y;
    }
};

bool sm(int a, int b) {
    return a >= 0 && b >= 0 || a <= 0 && b <= 0;
}

bool diff(int a, int b) {
    return a >= 0 && b <= 0 || a <= 0 && b >= 0;
}

bool inter(int a, int b, int c, int d) {
    if (a > b) swap(a, b);
    if (c > d) swap(c, d);
    return b >= c && d >= a;
}

bool inter(point a1, point a2, point b1, point b2) {
    if (!inter(a1.x, a2.x, b1.x, b2.x) || !inter(a1.y, a2.y, b1.y, b2.y)) return false;
    point dv = a2 - a1;
    int mt1 = (dv ^ (b1 - a1));
    int mt2 = (dv ^ (b2 - a1));
    int mt3 = ((b2 - b1) ^ (a1 - b1));
    int mt4 = ((b2 - b1) ^ (a2 - b1));
    return diff(mt1, mt2) || diff(mt3, mt4);
}

bool ray(point a, point v, point c, point d) {
    return inter(a, a + v, c, d);
}

const int inf = 1e9;

signed main()
{
    fast();
#ifdef DEBUG
    //freopen("in", "r", stdin);
#endif
    int n;
    cin >> n;
    for (int i = 0; i < n; i++) {
        point a1, a2, b1, b2, v;
        a1.scan(); a2.scan(); b1.scan(); b2.scan(); v.scan();
        int A = -v.y;
        int B = v.x;
        int l = -A * a1.x - B * a1.y;
        int r = -A * a2.x - B * a2.y;
        if (l > r) swap(l, r);
        vector<point> pp = {b1};
        int d = inf / max(llabs(v.x), llabs(v.y));
        v = v * d;
        bool fl = false;
        point dv = a2 - a1;
        if (!(dv ^ v)) {
            if (ray(a1, v, b1, b2)) {
                cout << "Yes\n";
            } else {
                cout << "No\n";
            }
            continue;
        }
        for (auto p : pp) {
            int c = -A * p.x - B * p.y;
            if (c < l || c > r) continue;
            if (sm(dv ^ v, dv ^ (p - a1))) {
                cout << "Yes\n";
                fl = true;
                break;
            }
        }
        if (!fl) {
            if (ray(a1, v, b1, b2) ^ ray(a2, v, b1,  b2)) exit(-1);
            if (ray(a1, v, b1, b2) || ray(a2, v, b1, b2)) {
                cout << "Yes\n";
            } else {
                cout << "No\n";
            }
        }
    }

    return 0;
}