#include <bits/stdc++.h>

using namespace std;
using li = long long;

struct Vect {
    int x, y;

    Vect(int xx, int yy) : x(xx), y(yy) {};
};

li vect(Vect v, Vect u) {
    return v.x * 1ll * u.y - v.y * 1ll * u.x;
}

li scal(Vect v, Vect u) {
    return v.x * 1ll * u.x + v.y * 1ll * u.y;
}

int svect(Vect v, Vect u) {
    li res = vect(v, u);
    if(res > 0)
        return 1;
    else if(res < 0)
        return -1;
    else
        return 0;
}

bool is(Vect a, Vect c, Vect d, Vect v) {
    Vect ac(c.x - a.x, c.y - a.y), ad(d.x - a.x, d.y - a.y);
    //bool res = svect(ac, v) != 0 && svect(ac, v) == svect(ac, ad) && svect(v, ad) == svect(ac, ad);
    bool res = vect(ac, v) > 0 && vect(ac, ad) > 0 && vect(v, ad) > 0;
    res = res ||  vect(ac, v) < 0 && vect(ac, ad) < 0 && vect(v, ad) < 0;
    //cout << res << endl;
    return res;
}

bool is1(Vect a, Vect c, Vect v) {
    Vect ac(c.x - a.x, c.y - a.y);
    return (vect(ac, v) == 0 && scal(ac, v) > 0);
}

/*
2
0 2 1 1 2 2 3 1 1 1
0 2 1 1 2 2 3 1 -1 -1

1
1 2
2 4
3 5
5 3
3 0

1
0 1
0 2
0 -1
0 -2
10 0

1
0 1
0 2
1 0
1 1
10 0

1
1 1
2 2
3 3
4 4
9 10

1
0 1
0 2
1 0
-2 0
0 10

1
0 0
0 5
1 1
5 1
5 1

1
0 0
2 2
7 2
12 -3
6 -1
*/

void solve() {
    int ax, ay, bx, by, cx, cy, dx, dy, vx, vy;
    cin >> ax >> ay >> bx >> by >> cx >> cy >> dx >> dy >> vx >> vy;

    Vect a(ax, ay), b(bx, by), c(cx, cy), d(dx, dy), v(vx, vy);

    bool ans = is(a, c, d, v) || is(b, c, d, v) || is(b, d, c, v) || is(a, d, c, v);

    ans = ans || is1(a, c, v) || is1(a, d, v) || is1(b, c, v) || is1(b, d, v);

    if(ans)
        cout << "Yes" << endl;
    else
        cout << "No" << endl;
}

int main() {
    int n;
    cin >> n;

    while(n--)
        solve();
}
