#include <bits/stdc++.h>
using namespace std;

string to_q(vector<vector<bool>> &mv, int n, int m) {
    string res;
    int x = 1, y = 1;
    while (x != n || y != m) {
        if (mv[x + 1][y]) {
            res += 'D';
            x++;
        } else {
            res += 'R';
            y++;
        }
    }
    return res;
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
//    ifstream cin ("input");
    int n, m;
    cin >> n >> m;
    vector<pair<pair<int, int>, pair<int, int>>> seg = {{{1, n}, {1, m}}};
    while (true) {
        vector<vector<bool>> mv(n + 2, vector<bool>(m + 2));
        bool final = true;
        for (auto p: seg) {
            int vl = p.first.first;
            int vr = p.first.second;
            int hl = p.second.first;
            int hr = p.second.second;
            //cerr << vl << ' ' << vr << ' ' << hl << ' ' << hr << endl;
            if (vl == vr || hl == hr) {
                for (int i = vl; i <= vr; i++) {
                    for (int j = hl; j <= hr; j++) {
                        mv[i][j] = true;
                    }
                }
                continue;
            }
            final = false;
            int vx = (vl + vr) / 2;
            for (int j = hl; j <= hr; j++) {
                mv[vx][j] = true;
            }
            for (int i = vl; i <= vx; i++) {
                mv[i][hl] = true;
            }
            for (int i = vx; i <= vr; i++) {
                mv[i][hr] = true;
            }
        }
        if (final) {
            cout << "! " << to_q(mv, n, m) << endl;
            break;
        }
        cout << "? " << to_q(mv, n, m) << endl;
        int k;
        cin >> k;
        vector<vector<bool>> match(n + 1, vector<bool>(m + 1));
        for (int i = 0; i < k; i++) {
            int v, h;
            cin >> v >> h;
            match[v][h] = true;
        }
        vector<pair<pair<int, int>, pair<int, int>>> new_seg;
        for (auto p: seg) {
            int vl = p.first.first;
            int vr = p.first.second;
            int hl = p.second.first;
            int hr = p.second.second;
            if (vl == vr || hl == hr) {
                new_seg.push_back(p);
                continue;
            }
            if (vr == vl + 1) {
                int x = hl;
                while (match[vl][x])
                    x++;
                x--;
                new_seg.push_back({{vl, vl}, {hl, x}});
                new_seg.push_back({{vr, vr}, {x, hr}});
                continue;
            }
            int vx = (vl + vr) / 2;
            int l = hl;
            while (!match[vx][l])
                l++;
            int r = l;
            while (match[vx][r])
                r++;
            r--;
            new_seg.push_back({{vl, vx},
                               {hl, l}});
            new_seg.push_back({{vx, vx},
                               {l,  r}});
            new_seg.push_back({{vx, vr},
                               {r,  hr}});
        }
        seg = new_seg;
    }
    return 0;
}