#include "iostream"
#include "algorithm"
#include "set"
#include "vector"
#include "string"
#include "math.h"
#include "map"
#include "deque"
#include "stack"
#include "queue"
#include "unordered_map"
#include "unordered_set"
#include "iomanip"
#define ll long long
#define ld long double
#define w while
#define forn(i, n) for (i = 0; i < n; i++)
#define con continue
#define br break
#define int signed
using namespace std;

ll gcd(ll a, ll b) {
	return b ? gcd(b, a % b) : a;
}
ll binpow(ll a, ll n) {
	ll res = 1;
	w(n) {
		if (n & 1)
			res *= a;
		a *= a;
		n >>= 1;
	}
	return res;
}

vector <pair <ll, ll>> ans_now;
vector <char> way;
vector <pair <ll, ll>> new_ans;
vector <pair <ll, ll>> got_ans;
ll n, m;

void get_way(ll n, ll m, ll a, ll b, bool down)
{
	ll x, y;
	x = a;
	y = b;
	while (x < a + n - 1 && y < b + m - 1)
	{
		if (down)
		{
			way.push_back('D');
			x++;
		}
		else
		{
			way.push_back('R');
			y++;
		}
		down = !down;
	}
	while (x != a + n - 1 || y != b + m - 1)
	{
		if (x != a + n - 1)
		{
			way.push_back('D');
			x++;
		}
		else
		{
			way.push_back('R');
			y++;
		}
	}

}

void get_ans(ll n, ll m, ll a, ll b, ll &step_num, ll &ans_num)
{
	ll x, y;
	x = a;
	y = b;

	while (x < a + n - 1 || y < b + m - 1)
	{
		while (x == got_ans[ans_num].first && y == got_ans[ans_num].second)
		{
			if (x == a + n - 1 && y == b + m - 1) goto end1;
			new_ans.push_back({ x, y });
			if (way[step_num] == 'D')
			{
				x++;
			}
			else
			{
				y++;
			}
			step_num++;
			ans_num++;
		}
		if (way[step_num - 1] == 'D')
		{
			new_ans.push_back({ x - 1, y + 1 });
		}
		else
		{
			new_ans.push_back({ x + 1, y - 1 });
		}
		while ((x != got_ans[ans_num].first || y != got_ans[ans_num].second))
		{
			if (way[step_num] == 'D')
			{
				x++;
			}
			else
			{
				y++;
			}
			step_num++;
		}
	}

end1:
	return;
}

bool near(ll i, ll j)
{
	return abs(ans_now[i].first - ans_now[j].first) + abs(ans_now[i].second + ans_now[j].second) == 1;
}

char step(pair<ll, ll> a, pair <ll, ll>b)
{
	if (abs(a.first - b.first) == 1)
	{
		return 'D';
	}
	return 'R';
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	cin >> n >> m;

	ans_now.push_back({ 1, 1 });
	ans_now.push_back({ n, m });

	while (ans_now.size() < n - 1 + m)
	{
		way.clear();
		new_ans.clear();
		got_ans.clear();
		ll i = 0;
		while (true)
		{
			ll j = i;
			while (true)
			{
				if (j == ans_now.size() - 1)
				{
					goto end;
				}
				if (!near(j, j + 1)) break;
				way.push_back(step(ans_now[j], ans_now[j + 1]));
				j++;
			}
			if (j == ans_now.size()) break;
			get_way(ans_now[j + 1].first - ans_now[j].first + 1, ans_now[j + 1].second - ans_now[j].second + 1, ans_now[j].first, ans_now[j].second, 1);
			i = j + 1;
		}
	end:

		cout << "? ";
		for (auto k : way) cout << k;
		cout << endl;

		ll t;
		cin >> t;
		for (ll k = 0; k < t; k++)
		{
			ll a, b;
			cin >> a >> b;
			got_ans.push_back({ a, b });
		}

		i = 0;
		ll step_num = 0, ans_num = 0;
		while (true)
		{
			ll j = i;
			new_ans.push_back(ans_now[i]);
			while (true)
			{
				if (j == ans_now.size() - 1)
				{
					goto end3;
				}
				if (!near(j, j + 1)) break;
				new_ans.push_back(ans_now[j]);
				step_num++;
				ans_num++;
				j++;
			}
			if (j == ans_now.size()) break;
			new_ans.pop_back();
			get_ans(ans_now[j + 1].first - ans_now[j].first + 1, ans_now[j + 1].second - ans_now[j].second + 1, ans_now[j].first, ans_now[j].second, step_num, ans_num);
			i = j + 1;
		}
	end3:

		ans_now = new_ans;
	}
	cout << "! ";
	for (ll i = 1; i < n + m - 1; i++)
	{
		cout << step(ans_now[i - 1], ans_now[i]);
	}
	cout << endl;
	return 0;
}