#pragma GCC optimize("O3,unroll-loops,inline,fast-math")
#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;
#define all(x) (x).begin(),(x).end()

struct point{
    ll x, y;
    point() {}
    point(ll a, ll b) {
        x = a, y = b;
    }
};

point operator-(const point & a, const point & b) {
    return point(a.x - b.x, a.y - b.y);
}

ll operator^(const point & a, const point & b) {
    return a.x * b.y - a.y * b.x;
}

#define vec point

bool check1(point a, point b1, point b2, vec v) {
    vec x1 = b1 - a;
    vec x2 = b2 - a;
    return (v ^ x1) > 0 && (v ^ x2) > 0;
}

bool check2(point a, point b1, point b2, vec v) {
    vec x1 = b1 - a;
    vec x2 = b2 - a;
    return (v ^ x1) > 0 && (v ^ x2) > 0;
}

void solve() {
    point a1, a2, b1, b2, v;
    cin >> a1.x >> a1.y >> a2.x >> a2.y >> b1.x >> b1.y >> b2.x >> b2.y >> v.x >> v.y;
    if (check1(a1, b1, b2, v) || check2(a2, b1, b2, v)) {
        cout << "No\n";
    }
    else {
        cout << "Yes\n";
    }
}

int main() {
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    cout.precision(20), cout.setf(ios::fixed);
    int t;
    cin >> t;
    while (t--)
        solve();
    return 0;
}


/*
 2
 0 2 1 1 2 2 3 1 1 1
 0 2 1 1 2 2 3 1 -1 -1
 */