#pragma GCC optimize("O3,unroll-loops,inline,fast-math")
#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;
#define all(x) (x).begin(),(x).end()

struct help{
    int d, m, y;
    help() {}
};

help get() {
    int a, b, c;
    char x;
    cin >> a >> x >> b >> x >> c;
    help ans;
    ans.y = c;
    ans.d = a;
    ans.m = b;
    assert(a != 0 && b != 0 && c != 0);
    if (x == '/')
        swap(ans.d, ans.m);
    return ans;
}

int len(int x) {
    int ans = 0;
    while (x) {
        ans++;
        x /= 10;
    }
    return ans;
}

string make(int x, int cnt) {
    int l = len(x);
    cnt -= l;
    string ans = "";
    while (x) {
        ans += '0' + x % 10;
        x /= 10;
    }
    while (cnt) {
        ans += "0";
        cnt--;
    }
    reverse(all(ans));
    return ans;
}

void out(help a) {
    string d = make(a.d, 2), m = make(a.m, 2), y = make(a.y, 4);
    cout << d << "." << m << "." << y << " " << m << "/" << d << "/" << y << "\n";
}

int main() {
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    cout.precision(20), cout.setf(ios::fixed);
    int n;
    cin >> n;
    vector<help> a;
    for (int i = 0; i < n; i++) {
        a.push_back(get());
    }
    for (auto i : a)
        out(i);
    return 0;
}

/*
 2
 11.12.2000
 1.2.1


 2
 20.10.2100
 1/29/3000
 */