#include <stdio.h>
#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

vector  <vector <bool> > used;



int main() {
    int n, m;
    scanf("%d%d", &n, &m);

    used.assign(n, vector <bool> (m, 0));

    used[0][0] = 1;
    used[n - 1][m - 1] = 1;

    vector <pair <int, int> > board_x;
    board_x.push_back({-1, m});

    vector <int> board_y(m, n - 1);

    for(int _q = 0; _q < 10; ++_q) {

        vector <pair <int, int> > __board_x;

        printf("? ");

        int _i = 0;
        int _j = 0;

        for(int cur = 0; cur < (int)board_x.size(); ++cur) {

            int mid = (board_x[cur].first + board_x[cur].second) / 2;

            for(int i = _i; i < mid; ++i) {
                printf("R");
                _i = i + 1;
            }

            for(int j = _j; j < board_y[mid]; ++j) {
                printf("D");
                _j = j + 1;
            }

            __board_x.push_back({board_x[cur].first, mid});
            __board_x.push_back({mid, board_x[cur].second});
        }

        for(int i = _i; i < m - 1; ++i) {
            printf("R");
        }

        for(int j = _j; j < n - 1; ++j) {
            printf("D");
        }

        printf("\n");
        fflush(stdout);

        board_x = __board_x;

        int num;
        scanf("%d", &num);

        while(num--) {

            int x, y;
            scanf("%d%d", &x, &y);

            used[x - 1][y - 1] = 1;
            board_y[y - 1] = x - 1;
        }
    }

    int i = 0;
    int j = 0;

    while(i < n - 1 || j < m - 1) {

        if(i + 1 < n && used[i + 1][j] == 1) {
            printf("D");
            ++i;
        }
        else {
            printf("R");
            ++j;
        }

    }

    printf("\n");
    fflush(stdout);

    return 0;
}
