import java.io.*;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.Locale;
import java.util.StringTokenizer;



public class B {
    
    class pt {
    long x, y;

    public pt(long x, long y) {
        this.x = x;
        this.y = y;
    }

    pt(){
        
    }
    
    void init() throws IOException {
        x = nextLong();
        y = nextLong();
    }
}
    long f(pt a, pt b) {
        BigInteger x1 = new BigInteger(a.x + "");
        BigInteger x2 = new BigInteger(b.x + "");
        BigInteger y1 = new BigInteger(a.y + "");
        BigInteger y2 = new BigInteger(b.y + "");
        BigInteger ans = x1.multiply(y2).subtract(x2.multiply(y1));
        return ans.compareTo(BigInteger.ZERO);
    }

    boolean ch(pt[] v, pt a) {
        long si = 0;
        int i;
        for (i = 0; si == 0 && i < 4; ++i) {
            pt nxt = v[(i + 1) % 4];
            si = f(new pt(a.x - v[i].x, a.y - v[i].y), new pt(nxt.x - v[i].x, nxt.y - v[i].y));
        }
        for (; i < 4; ++i) {
            pt nxt = v[(i + 1) % 4];
            long u = f(new pt(a.x - v[i].x, a.y - v[i].y), new pt(nxt.x - v[i].x, nxt.y - v[i].y));

            if (u != 0 && u != si) return false;
        }
        return true;
    }

    boolean ch2(pt a, pt b, pt c, pt d) {
        for (int e = 0; e < 1; ++e) {
            long si = f(new pt(c.x - a.x, c.y - a.y), new pt(b.x - a.x, b.y - a.y));
            if (si == 0) break;
            long si2 = f(new pt(d.x - a.x, d.y - a.y), new pt(b.x - a.x, b.y - a.y));
            if (si2 == 0) break;

            if (si == si2) return false;
        }

        pt t = c;
        c = a;
        a = t;

        t = d;
        d = b;
        b = t;

        long si = f(new pt(c.x - a.x, c.y - a.y), new pt(b.x - a.x, b.y - a.y));
        if (si == 0)
            return true;
        long si2 = f(new pt(d.x - a.x, d.y - a.y), new pt(b.x - a.x, b.y - a.y));
        if (si2 == 0) return true;

        return si != si2;
    }

    public void solve() throws IOException {
        int n = nextInt();
        pt a = new pt();
        pt b = new pt();
        pt c = new pt();
        pt d = new pt();
        pt v = new pt();
        for(int aksd = 0; aksd < n; ++aksd) {
            a.init();
            b.init();
            c.init();
            d.init();
            v.init();

            pt a2 = new pt(a.x + v.x * 1000 * 1000 * 1000, a.y + v.y * 1000 * 1000 * 1000);
            pt b2 = new pt(b.x + v.x * 1000 * 1000 * 1000, b.y + v.y * 1000 * 1000 * 1000);

            if(ch(new pt[]{a, b, b2, a2}, c) || ch(new pt[]{a, b, b2, a2}, d) || ch2(a, a2, c, d) || ch2(b, b2, c, d)){
                out.println("Yes");
            }else out.println("No");
        }
    }


    public void run() {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new B().run();
    }

}