#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

struct point{
    ld x, y;
    point(): x(0), y(0){};
    point(ld x, ld y): x(x), y(y){};
};

struct vec{
    ld x, y;
    vec(): x(0), y(0){};
    vec(ld x, ld y): x(x), y(y){};
    vec(point a, point b): x(b.x - a.x), y(b.y - a.y){};

    ld operator *(vec oth)
    {
        return x * oth.y - y * oth.x;
    }
    ld operator /(vec oth)
    {
        return x * oth.x + y * oth.y;
    }
};

ld sig(ld a)
{
    if (a < 0)
        return (ld)-1;
    if (a == 0)
        return (ld)0;
    return (ld)1;
}

int main()
{
    ios_base::sync_with_stdio();
    cin.tie();
    cout.tie(0);

    int n;
    cin >> n;
    for (int i = 0; i < n; i++)
    {
        point a, b, c, d;
        cin >> a.x >> a.y >> b.x >> b.y >> c.x >> c.y >> d.x >> d.y;
        vec v;
        cin >> v.x >> v.y;
        point av, bv;
        av.x = a.x + v.x;
        av.y = a.y + v.y;
        bv.x = b.x + v.x;
        bv.y = b.y + v.y;
        ld A = -v.y;
        ld B = v.x;
        ld C = -(A * a.x + B * a.y);
        ld C1 = -(A * b.x + B * b.y);
        vec cd(c, d);
        ld Ac = -cd.y;
        ld Bc = cd.x;
        ld Cc = -(Ac * c.x + Bc * c.y);
        if (A * Bc == B * Ac)
        {
            vec ac(a, c), ab(a, b), ad(a, d), bc(b, c), bd(b, d);
            if (((sig(ab * v) == sig(ab * ac) && (sig(ab * v) != 0 || (sig(ab * v) == 0 && sig(ab / v) == sig(ab / ac)))) && (sig(ac * v) != sig(bc * v) || sig(ac * v) == 0)) || ((sig(ab * v) == sig(ab * ad) && (sig(ab * v) != 0 || (sig(ab * v) == 0 && sig(ab / v) == sig(ab / ad)))) && (sig(ad * v) != sig(bd * v) || sig(ad * v) == 0)))
                cout << "Yes\n";
            else
                cout << "No\n";
            continue;
        }
        point x;
        x.y = (-Cc * A + C * Ac) / (A * Bc - B * Ac);
        x.x = (-C * Bc + B * Cc) / (A * Bc - B * Ac);
        if (C == C1)
        {
            vec ax(a, x), ab(a, b);
            if (x.x <= max(c.x, d.x) && x.x >= min(c.x, d.x) && x.y >= min(c.y, d.y) && x.y <= max(c.y, d.y) && sig(ab * v) == sig(ab * ax))
                cout << "Yes\n";
            else
                cout << "No\n";
            continue;
        } else {
            point y;
            y.y = (-Cc * A + C1 * Ac) / (A * Bc - B * Ac);
            y.x = (-C1 * Bc + B * Cc) / (A * Bc - B * Ac);
            vec ab(a, b), ax(a, x), ay(a, y);
            if ((x.x <= max(c.x, d.x) && x.x >= min(c.x, d.x) && x.y >= min(c.y, d.y) && x.y <= max(c.y, d.y) && sig(ab * v) == sig(ab * ax)) || (y.x <= max(c.x, d.x) && y.x >= min(c.x, d.x) && y.y >= min(c.y, d.y) && y.y <= max(c.y, d.y) && sig(ab * v) == sig(ab * ay)))
                cout << "Yes\n";
            else
                cout << "No\n";
       }
    }
    return 0;
}
