#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define F first
#define S second
#define fst first
#define sbd second
#define forn(i0, n0) for(int i0 = 0; i0<n0; i0++)
#define forab(i0, a0, b0) for(int i0 = a0; i0<b0; i0++)
#define all(x) x.begin(), x.end()
#define ld long double
#define pb push_back
#define pii pair<int, int>
#define vpii vector<pii>
typedef vector<int> vi;
typedef vector<vector<int>> vvi;

string go(pii p1, pii p2, vvi &mem){
    int x1 = p1.first, x2 = p2.first;
    int y1 = p1.second, y2 = p2.second;
    string ans;
    if (x2 == x1 + 1 && y2 > y1 && mem[x1][y1 + 1] == 2){
        ans += "D";
        while(y1 < y2){
            ans += "R";
            y1++;
        }
        return ans;
    }
    if (x2 == x1 + 1 && y2 > y1 && mem[x1 + 1][y1] == 2){
        return "R" + go({x1, y1 + 1}, p2, mem);
    }
    int xm = (x1 + x2 + 1) / 2;
    while(x1 < xm){
        x1++;
        ans += "D";
    }
    while (y1 < y2){
        y1++;
        ans += "R";
    }
    while(x1 < x2){
        x1++;
        ans += "D";
    }
    return ans;
}

int main() {
    //ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n, m;
    cin >> n >> m;
    vpii path;
    path.pb({1, 1});
    path.pb({n, m});
    ll siz = n + m - 2;
    vvi mem(n + 1, vi(m + 1));
    while (path.size() <= siz){
        string s;
        forn(i, path.size() - 1) s += go(path[i], path[i + 1], mem);
        bool flag = 1;
        forn(i, path.size() - 1) {
            int x1 = path[i].first, y1 = path[i].second;
            int x2 = path[i + 1].first, y2 = path[i + 1].second;
            //cout << "a " << x1 << ' ' << y1 << ' ' << x2 << ' ' << y2 << '\n';
            forab(x, x1, x2) {
                forab(y, y1, y2) {
                    if (mem[x][y + 1] < 2 && mem[x + 1][y] < 2) {
                        flag = 0;
                        break;
                    }
                }
            }
        }
        if (flag){
            cout << "! " << s << '\n';
            return 0;
        }
        cout << "? " << s << '\n';
        vpii xy;
        xy.pb({1, 1});
        ll X = 1, Y = 1;
        forn(i, s.length()){
            if (s[i] == 'R') Y++; else X++;
            xy.pb({X, Y});
        }
        fflush(stdout);
        int k;
        cin >> k;
        forn(i, k){
            int x, y;
            cin >> x >> y;
            path.pb({x, y});
        }
        set<pii> path1;
        for (pii p : path) path1.insert(p);
        path.clear();
        for (pii p : path1) path.pb(p);
        for (pii p : xy){
            if (path1.count(p)) mem[p.first][p.second] = 1; else mem[p.first][p.second] = 2;
        }
//                forn(i, n + 1){
//            forn(j, m + 1) cout << mem[i][j] << ' ';
//            cout << '\n';
//        }
    }
    string s;
    forn(i, path.size() - 1){
        int x1 = path[i].first, y1 = path[i].second;
        int x2 = path[i + 1].first, y2 = path[i + 1].second;
        if (x1 == x2) s += "R"; else s += "D";
    }
    cout << "! " << s << '\n';
    return 0;
}