#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#define LL long long
#define MP make_pair
#define mod 1000000007ll
using namespace std;
typedef long double ldouble;
struct pt
{
	ldouble x, y;
	pt(ldouble X = 0, ldouble Y = 0)
	{
		x = X;
		y = Y;
	}
};
/*
LL area(pt a, pt b, pt c)
{
	return abs(a.x * (b.y - c.y) + b.x * (c.y - a.y) + c.x * (a.y - b.y));
}
LL isIn(pt a, pt b, pt c, pt d, pt p)
{
	return (area(c, d, a) + area(a, b, c) == (area(a, b, p) + area(b, c, p) + area(c, d, p) + area(d, a, p)));
}
*/
pt a1, a2, b1, b2, v;

pair <ldouble, ldouble> get(pt a, pt b) {
	ldouble k = (ldouble)(b.y - a.y) / (b.x - a.x);
	ldouble B = (ldouble)a.y - k * 1. * a.x;
	pair <ldouble, ldouble> res;
	res.first = k;
	res.second = B;
	return res;
}

const ldouble E = 0.0000001L;

int main()
{
	ios::sync_with_stdio(false);
	cin.tie(0); cout.tie(0);

	int n;
	cin >> n;
	while (n--)
	{
		cin >> a1.x >> a1.y >> a2.x >> a2.y;
		cin >> b1.x >> b1.y >> b2.x >> b2.y;
		cin >> v.x >> v.y;
		if (a1.x > a2.x)
			swap(a1, a2);
		if (b1.x > b2.x)
			swap(b1, b2);
		if (v.y < 0) {
			swap(a1, a2);
		}

		if (v.x == 0) {
			if (v.y > 0) {
				if (b1.y <= a1.y && b2.y <= a2.y) {
					cout << "No\n";
				}
				else if (a1.x >= b1.x && a1.x <= b2.x) {
					cout << "Yes\n";
				}
				else if (a1.x <= b1.x && a2.x >= b2.x) {
					cout << "Yes\n";
				}
				else if (a2.x >= b1.x && a2.x <= b2.x) {
					cout << "Yes\n";
				}
				else {
					cout << "No\n";
				}
			}
			else {
				swap(a1, a2);
				if (b1.y >= a1.y && b2.y >= a2.y) {
					cout << "No\n";
				}
				else if (a1.x >= b1.x && a1.x <= b2.x) {
					cout << "Yes\n";
				}
				else if (a1.x <= b1.x && a2.x >= b2.x) {
					cout << "Yes\n";
				}
				else if (a2.x >= b1.x && a2.x <= b2.x) {
					cout << "Yes\n";
				}
				else {
					cout << "No\n";
				}
			}
			continue;
		}
		else if (fabs(v.y) < E) {
			swap(a1.x, a1.y);
			swap(a2.x, a2.y);
			swap(b1.x, b1.y);
			swap(b2.x, b2.y);
			if (v.x > 0) {
				if (b1.y <= a1.y && b2.y <= a2.y) {
					cout << "No\n";
				}
				else if (a1.x >= b1.x && a1.x <= b2.x) {
					cout << "Yes\n";
				}
				else if (a1.x <= b1.x && a2.x >= b2.x) {
					cout << "Yes\n";
				}
				else if (a2.x >= b1.x && a2.x <= b2.x) {
					cout << "Yes\n";
				}
				else {
					cout << "No\n";
				}
			}
			else {
				swap(a1, a2);
				if (b1.y >= a1.y && b2.y >= a2.y) {
					cout << "No\n";
				}
				else if (a1.x >= b1.x && a1.x <= b2.x) {
					cout << "Yes\n";
				}
				else if (a1.x <= b1.x && a2.x >= b2.x) {
					cout << "Yes\n";
				}
				else if (a2.x >= b1.x && a2.x <= b2.x) {
					cout << "Yes\n";
				}
				else {
					cout << "No\n";
				}
			}
			continue;
		}

		v.x = (ldouble)v.y / v.x;
		
		/*	bool ans = false;
			pt A1 = a1, A2 = a2;
			A1.x += mod * v.x;
			A1.y += mod * v.y;
			A2.x += mod * v.x;
			A2.y += mod * v.y;
			if (isIn(a1, A1, A2, a2, b1) || isIn(a1, A1, A2, a2, b2))
				ans = true;
			if ()
			if (ans)
				cout << "Yes\n";
			else
				cout << "No\n";*/

				/*pt av1, av2;
				av1.x = a1.x + v.x;
				av1.y = a1.y + v.y;
				av2.x = a2.x + v.x;
				av2.y = a2.y + v.y;*/
		pair <ldouble, ldouble> tmp11 = get(a1, b1);
		pair <ldouble, ldouble> tmp12 = get(a1, b2);
		pair <ldouble, ldouble> tmp21 = get(a2, b1);
		pair <ldouble, ldouble> tmp22 = get(a2, b2);

		if (tmp11.first + E <= (ldouble)v.x && tmp12.first + E <= (ldouble)v.x && tmp21.first >= E + (ldouble)v.x && tmp22.first >= (ldouble)v.x) {
			cout << "Yes\n";
		}
		else if (tmp11.first >= E + (ldouble)v.x && tmp12.first >= E + (ldouble)v.x) {
			cout << "Yes\n";
		}
		else if (tmp11.first + E <= (ldouble)v.x && tmp12.first + E <= (ldouble)v.x && tmp21.first >= E + (ldouble)v.x && tmp22.first + E <= (ldouble)v.x) {
			cout << "Yes\n";
		}
		else if (tmp21.first >= E + (ldouble)v.x && tmp22.first + E <= (ldouble)v.x) {
			cout << "Yes\n";
		}
		else {
			cout << "No\n";
		}
	}
}