#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#define LL long long
#define MP make_pair
#define PB push_back
#define mod 1000000007ll
using namespace std;

const int N = 1003;

pair<int, int> ind[N+N][N],pos[N][N];
pair<int, int> lr[N+N];

int main()
{
	int n, m;
	cin >> n >> m;
	for (int i = 1; i <= min(n, m); ++i)
	{
		lr[i] = MP(1, i);
		int y=i,x=1;
		for (int j = lr[i].first; j <= lr[i].second; j++)
		{
			ind[i][j] = MP(y,x);
			pos[y][x] = MP(i, j);
			y--;
			x++;
		}
	}
	for (int i = min(n, m) + 1; i <= max(n, m); ++i)
	{
		lr[i] = MP(1, min(n, m));
		int y = min(i,n), x = max(1,i+1-n);
		for (int j = lr[i].first; j <= lr[i].second; j++)
		{
			ind[i][j] = MP(y, x);
			pos[y][x] = MP(i, j);
			y--;
			x++;
		}
	}
	for (int i = max(n, m) + 1; i <= n + m - 1; ++i)
	{
		lr[i] = MP(1, min(n, m) - (i - max(m, n)));
		int y = n, x = i-n+1;
		for (int j = lr[i].first; j <= lr[i].second; j++)
		{
			ind[i][j] = MP(y, x);
			pos[y][x] = MP(i, j);
			y--;
			x++;
		}
	}

	int Q = 10;
	while (Q--)
	{
		vector<pair<int, int>> v;
		for (int i = 1; i <= n + m - 1; i++)
		{
			int mid = (lr[i].first + lr[i].second) / 2;
			v.PB(ind[i][mid]);
			//cout << ind[i][mid].first << " " << ind[i][mid].second << endl;
		}
		string query="? ";
		for (int i = 1; i < v.size(); i++)
			if (v[i].first == v[i - 1].first)
				query += "R";
			else
				query += "D";
		cout << query << "\n";
		cout << flush;
		int k;
		cin >> k;
		v.clear();
		while (k--)
		{
			int y, x;
			cin >> y >> x;
			v.PB(pos[y][x]);
		}
		for (int i = 0; i < v.size()-1; i++)
		{
			int mid = (lr[i].first + lr[i].second) / 2;
			for (int j = v[i].first; j < v[i + 1].first;j++)
			{
				int newmid = (lr[j].first + lr[j].second) / 2;
				if (v[i].second > mid)
					lr[j].first = newmid + 1;
				else
					lr[j].second = newmid;
			}
			lr[v[i].first].first = lr[v[i].first].second = v[i].second;
		}
		lr[v[v.size()-1].first].first = lr[v[v.size() - 1].first].second = v[v.size() - 1].second;
		if (v.size() == n + m - 1)
			break;
	}
	vector<pair<int, int>> v;
	for (int i = 1; i <= n + m - 1; i++)
	{
		int mid = (lr[i].first + lr[i].second) / 2;
		v.PB(ind[i][mid]);
	}
	string query = "! ";
	for (int i = 1; i < v.size(); i++)
		if (v[i].first == v[i - 1].first)
			query += "R";
		else
			query += "D";

	cout << query << endl;
}

/*

3 4
5
1 1
2 2
2 3
3 3
3 4

*/